<?php
/******************************************************************************/
//                                                                            //
//                             InstantCMS 2                                   //
//                        http://instantcms.ru/                               //
//                   produced by InstantSoft, instantsoft.ru                  //
//                        LICENSED BY GNU/GPL v2                              //
//                                                                            //
/******************************************************************************/

    // >> <WebMan>  - debug
    $start_data = array();
    $start_data['time'] = microtime(true);
    $start_data['memory'] = memory_get_usage();
    $start_data['memory_real'] = memory_get_usage(true);

    session_start();

    define('VALID_RUN', true);

    // Если разрешено, загружаем и включаем функции отладки
    $debug_cgf = require_once 'system/config/debug.php';
    if (DEBUG_ON) {
        include_once 'system/core/debugconfig.php';
        include_once 'system/core/debug.php';
        cmsDebug::getInstance($debug_cgf, $start_data);
        unset($debug_cgf);
        unset($start_data);
    }
    // << </WebMan> - debug

	// Устанавливаем кодировку
	header('Content-type:text/html; charset=utf-8');
    header('X-Powered-By: InstantCMS 2');

    require_once 'bootstrap.php';

    // >> <WebMan>  - debug
    if (DEBUG_ON) { usleep(cmsDebugConfig::getInstance()->emulate_lag * 1000); }
    // << </WebMan> - debug

    //Запускаем роутинг
    $core->route($_SERVER['REQUEST_URI']);

    // Инициализируем шаблонизатор
    $template = cmsTemplate::getInstance();

    if (href_to('auth', 'login') != $_SERVER['REQUEST_URI']){
        if (!$config->is_site_on && !cmsUser::isAdmin()) {
            cmsCore::errorMaintenance();
        }
    }

    cmsEventsManager::hook('engine_start');

    //Запускаем контроллер
	$core->runController();
    $core->runWidgets();

    //Выводим готовую страницу
    $template->renderPage();

    cmsEventsManager::hook('engine_stop');

    // Останавливаем кеш
    cmsCache::getInstance()->stop();

    // >> <WebMan>  - debug
    // Если разрешено, выводим информацию отладки
    if (DEBUG_ON && cmsDebug::getInstance()->isAllowShow()) { echo cmsDebug::getInstance()->getHtmlFull(); }

    // =============================================================================
    /**
    * Функция для упрощения вызовов контрольных точек при отладке (DebugCheckPoint)
    * Без неё вызов КТ осуществляется через условие:
    * if (DEBUG_ON) { cmsDebug::getInstance()->checkPoint('NAME','param='.$param, 5, true, true); }
    * Входные параметры те же, что и у функции cmsDebug->checkPoint()
    * Все параметры необязательные
    * @param string $name Название точки, выводится в лог в кавычках после "CheckPoint"
    * @param mixed $params Параметры для лога
    * @param int $trace_level Глубина трассировки вызовов, 0 - выключить, '' - по умолчанию из конфига
    * @param bool $sql_debug Временно включить показ SQL с этой контрольной точки
    * @param bool $include_debug Временно включить показ инклудов с этой контрольной точки
    */
    function dcp($name='', $params='', $trace_level='', $sql_debug = false, $include_debug = false) {
        if (DEBUG_ON) { cmsDebug::getInstance()->checkPoint($name, $params, $trace_level, $sql_debug, $include_debug); }
    }
    // << </WebMan>  - debug
