<?php // by WebMan v.10.2.261 (10.12.2016)

if(!defined('VALID_RUN')) { die('ACCESS DENIED'); }

class cmsDebug {

    private static $instance;

    const VERSION = '10.2.261';

    // Константы кодов ошибок инклудов
    const INCLUDE_OK        = 0;  // Без ошибок
    const INCLUDE_NOT_FOUND = 1;  // Файл не найден
    const INCLUDE_ALREADY   = 2;  // Файл уже подключён

    private $include_codes = array(
        self::INCLUDE_OK        => 'OK',
        self::INCLUDE_NOT_FOUND => 'File not found',
        self::INCLUDE_ALREADY   => 'File already included'
    );

    private $include_codes_css = array(
        self::INCLUDE_OK        => 'ok',
        self::INCLUDE_NOT_FOUND => 'error',
        self::INCLUDE_ALREADY   => 'warning'
    );

    public $config;  // Текущая рабочая конфигурация

    //----------------------------------------------------------------------------
    // Массив с информацией об отладке, доступный снаружи через get()
    // (время - в округлённых милисекундах)
    // Актуализируется на текущий момент из локальных переменных вызовом calcDebug()
    private $data = array(
        'full_time'           => 0,  // Полное время выполнения (скрипт + отладка)
        'script_time'         => 0,  // Время выполнения скрипта (без учёта времени отладки)
        'debug_time'          => 0,  // Суммарное время, потраченное модулем отладки
        'start_time'          => 0,  // Время с момента получения запроса сервером до старта скрипта

        'php_time'            => 0,  // Суммарное время выполнения php в скрипте (без SQL)

        'point_count'         => 0,  // Количество контрольных точек

        'sql_time'            => 0,  // Суммарное время всех подключений и запросов к БД
        'sql_time_connect'    => 0,  // Суммарное время всех подключений к БД
        'sql_time_query'      => 0,  // Суммарное время всех запросов
        'sql_count_connect'   => 0,  // Количество подключений к БД
        'sql_count_query'     => 0,  // Количество запросов к БД
        'sql_filter_count'    => 0,  // Количество отфильтрованных в лог запросов к БД
        'sql_errors'          => 0,  // Количество запросов с ошибками
        'sql_warnings'        => 0,  // Количество запросов с предупреждениями

        'auto_time'           => 0,  // Суммарное время всех автозагрузок классов
        'auto_count'          => 0,  // Количество автозагрузок классов
        'auto_filter_count'   => 0,  // Количество отфильтрованных в лог автозагрузок

        'include_time'        => 0,  // Суммарное время всех инклудов
        'include_count'       => 0,  // Количество инклудов
        'include_filter_count'=> 0,  // Количество отфильтрованных в лог инклудов

        'hook_time'           => 0,  // Суммарное время всех хуков
        'hook_count'          => 0,  // Количество отработавших хуков
        'hook_events'         => 0,  // Количество произошеших событий
        'hook_memory'         => 0,  // Использование памяти хуками
        'hook_filter_count'   => 0,  // Количество отфильтрованных в лог хуков
        'hook_filter_events'  => 0,  // Количество отфильтрованных в лог событий

        'widget_time'         => 0,  // Суммарное время всех виджетов
        'widget_count'        => 0,  // Количество виджетов
        'widget_memory'       => 0,  // Использование памяти виджетами
        'widget_filter_count' => 0,  // Количество отфильтрованных в лог виджетов

        'control_time'        => 0,  // Время работы контроллера
        'control_count'       => 0,  // Количество запусков контроллера
        'control_memory'      => 0,  // Использование памяти контроллером
        'control_memory_type' => '', // Тип расчёта памяти (peak - по пику, end - по окончанию)

        'template_time'         => 0,  // Время инициализации шаблона
        'template_count'        => 0,  // Количество инициализаций шаблона
        'template_memory'       => 0,  // Использование памяти при инициализации шаблона
        'template_memory_type'  => '', // Тип расчёта памяти (peak - по пику, end - по окончанию)

        'render_time'         => 0,  // Время отрисовки всей страницы
        'render_count'        => 0,  // Количество запусков отрисовки
        'render_memory'       => 0,  // Использование памяти при отрисовке страницы
        'render_memory_type'  => '', // Тип расчёта памяти (peak - по пику, end - по окончанию)

        'cache_time'              => 0,  // Суммарное время всех обращений к кэшу
        'cache_time_set'          => 0,  // Суммарное время всех обращений SET к кэшу
        'cache_time_get'          => 0,  // Суммарное время всех обращений GET к кэшу
        'cache_count_set'         => 0,  // Количество обращений SET к кэшу
        'cache_count_get'         => 0,  // Количество обращений GET к кэшу
        'cache_filter_count_set'  => 0,  // Количество отфильтрованных в лог обращений SET к кэшу
        'cache_filter_count_get'  => 0,  // Количество отфильтрованных в лог обращений GET к кэшу

        'memory_start'        => 0,  // Начальное значение памяти скрипта, в МБ
        'memory_end'          => 0,  // Конечное значение памяти скрипта и отладки, в МБ
        'memory_peak'         => 0,  // Максимальное использование памяти скриптом и отладкой, в МБ
        'memory_script_peak'  => 0,  // Максимальное использование памяти скриптом без отладки, в МБ
        'debug_memory'        => 0,  // Память, использованная модулем отладки, в МБ
    );

    //----------------------------------------------------------------------------
    // Переменные
    private $time_start         = 0;  // Время старта скрипта
    private $debug_time_start   = 0;  // Время старта участка кода отладки
    private $debug_time         = 0;  // Суммарное время, потраченное модулем отладки, в секундах
    private $debug_memory       = 0;  // Суммарная память, использованная модулем отладки, в байтах
    private $debug_memory_start = 0;  // Значение памяти на момент старта участка кода отладки, в байтах

    private $point_time_last          = 0;  // Время предыдущей контрольной точки
    private $point_sql_time_last      = 0;  // Время коннектов и запросов к БД в предыдущей контрольной точке
    private $point_sql_count_last     = 0;  // Количество коннектов и запросов к БД в предыдущей контрольной точке
    private $point_include_time_last  = 0;  // Время автозагрузок и инклудов в предыдущей контрольной точке
    private $point_include_count_last = 0;  // Количество автозагрузок и инклудов в предыдущей контрольной точке
    private $point_hook_time_last     = 0;  // Время хуков в предыдущей контрольной точке
    private $point_hook_count_last    = 0;  // Количество хуков в предыдущей контрольной точке
    private $point_hook_events_last   = 0;  // Количество событий в предыдущей контрольной точке
    private $point_memory_last        = 0;  // Значение памяти в предыдущей контрольной точке
    private $point_debug_on_sql       = false;  // Временно включить показ коннектов и запросов к БД после этой контрольной точки
    private $point_debug_on_include   = false;  // Временно включить показ автозагрузок и инклудов после этой контрольной точки

    private $sql_time_start     = 0;  // Время старта запроса SQL, пересчитывается для каждого запроса
    private $sql_time_connect   = 0;  // Суммарное время всех подключений к БД в секундах
    private $sql_time_query     = 0;  // Суммарное время всех запросов в секундах
    private $sql_filter_on      = 0;  // Признак того, что фильтр включался хоть раз

    private $auto_time_start    = 0;  // Время старта автозагрузки ядра и классов, пересчитывается для каждой загрузки
    private $auto_time          = 0;  // Суммарное время всех автозагрузок в секундах
    private $auto_filter_on     = 0;  // Признак того, что фильтр включался хоть раз

    private $include_time_start = 0;  // Время старта инклуда, пересчитывается для каждого инклуда
    private $include_time       = 0;  // Суммарное время всех инклудов в секундах
    private $include_filter_on  = 0;  // Признак того, что фильтр включался хоть раз

    private $cache_time_start   = 0;  // Время старта обращения к кэшу, пересчитывается при каждом обращении
    private $cache_time_set     = 0;  // Суммарное время всех обращений SET к кэшу в секундах
    private $cache_time_get     = 0;  // Суммарное время всех обращений GET к кэшу в секундах

    private $hook_time_start    = 0;  // Время старта хука, пересчитывается для каждого хука
    private $hook_time          = 0;  // Суммарное время всех хуков в секундах
    private $hook_memory_start  = 0;  // Память на момент старта хука
    private $hook_memory_peak   = 0;  // Пик памяти на момент старта хука
    private $hook_sql_time      = 0;  // Время sql-запросов на момент старта хука
    private $hook_sql_count     = 0;  // Количество sql-запросов на момент старта хука
    private $hook_include_time  = 0;  // Время инклудов на момент старта хука
    private $hook_include_count = 0;  // Количество инклудов на момент старта хука

    private $widget_time_start    = 0;  // Время старта виджета, пересчитывается для каждого виджета
    private $widget_time_render   = 0;  // Время старта рендеринга виджета, пересчитывается для каждого виджета
    private $widget_time          = 0;  // Суммарное время всех виджетов в секундах
    private $widget_memory_start  = 0;  // Память на момент старта виджета
    private $widget_memory_peak   = 0;  // Пик памяти на момент старта виджета
    private $widget_sql_time      = 0;  // Время sql-запросов на момент старта виджета
    private $widget_sql_count     = 0;  // Количество sql-запросов на момент старта виджета
    private $widget_include_time  = 0;  // Время инклудов на момент старта виджета
    private $widget_include_count = 0;  // Количество инклудов на момент старта виджета
    private $widget_hook_time     = 0;  // Время хуков на момент старта виджета
    private $widget_hook_count    = 0;  // Количество хуков на момент старта виджета
    private $widget_hook_events   = 0;  // Количество событий на момент старта виджета

    private $control_time_start     = 0;  // Время старта контроллера
    private $control_memory_start   = 0;  // Память на момент старта контроллера
    private $control_memory_peak    = 0;  // Пик памяти на момент старта контроллера
    private $control_sql_time       = 0;  // Время sql-запросов на момент старта контроллера
    private $control_sql_count      = 0;  // Количество sql-запросов на момент старта контроллера
    private $control_include_time   = 0;  // Время инклудов на момент старта контроллера
    private $control_include_count  = 0;  // Количество инклудов на момент старта контроллера
    private $control_hook_time      = 0;  // Время хуков на момент старта контроллера
    private $control_hook_count     = 0;  // Количество хуков на момент старта контроллера
    private $control_hook_events    = 0;  // Количество событий на момент старта контроллера

    private $template_time_start    = 0;  // Время старта инициализации шаблона
    private $template_memory_start  = 0;  // Память на момент старта шаблона
    private $template_memory_peak   = 0;  // Пик памяти на момент старта шаблона
    private $template_sql_time      = 0;  // Время sql-запросов на момент старта шаблона
    private $template_sql_count     = 0;  // Количество sql-запросов на момент старта шаблона
    private $template_include_time  = 0;  // Время инклудов на момент старта шаблона
    private $template_include_count = 0;  // Количество инклудов на момент старта шаблона
    private $template_hook_time     = 0;  // Время хуков на момент старта шаблона
    private $template_hook_count    = 0;  // Количество хуков на момент старта шаблона
    private $template_hook_events   = 0;  // Количество событий на момент старта шаблона

    private $render_time_start    = 0;  // Время старта отрисовки страницы
    private $render_memory_start  = 0;  // Память на момент старта отрисовки
    private $render_memory_peak   = 0;  // Пик памяти на момент старта отрисовки
    private $render_sql_time      = 0;  // Время sql-запросов на момент старта отрисовки
    private $render_sql_count     = 0;  // Количество sql-запросов на момент старта отрисовки
    private $render_include_time  = 0;  // Время инклудов на момент старта отрисовки
    private $render_include_count = 0;  // Количество инклудов на момент старта отрисовки
    private $render_hook_time     = 0;  // Время хуков на момент старта отрисовки
    private $render_hook_count    = 0;  // Количество хуков на момент старта отрисовки
    private $render_hook_events   = 0;  // Количество событий на момент старта отрисовки

    private $includes = array();  // Массив инклудов

    private $events   = array();  // Массив событий
    private $hooks    = array();  // Массив хуков

    private $widgets  = array();  // Массив виджетов

    private $debug_html = '';  // html-строка с отладочной инфой

    private $errors_html = '';  // html-строка с инфой об ошибках PHP

// =============================================================================

    public function __construct($params='', $start_data='') {

        // Корректируем точность, чтобы хватило на один знак после запятой в микросекундах
        if (ini_get('precision') < 14) { ini_set('precision', '14'); }

        // Подготавливаем массив со стартовыми данными
        $debug_data = array('time' => 0, 'memory' => 0, 'memory_real' => 0);
        $start_data = array_merge($debug_data, $start_data);

        // Определяем время старта
        $this->time_start = ( $start_data['time'] > 0 ? $start_data['time'] : microtime(true) );
        $this->point_time_last = $this->time_start;

        // Определяем начальную память
        if ($start_data['memory'] == 0) { $start_data['memory'] = memory_get_usage(false); }
        if ($start_data['memory_real'] == 0) { $start_data['memory_real'] = memory_get_usage(true); }

        $this->config = cmsDebugConfig::GetInstance($params);

        // Выбираем начальную память в зависимости от режима
        $start_memory = ( $this->config->memory_real_usage ? $start_data['memory_real'] : $start_data['memory'] );
        $this->data['memory_start'] = $this->roundMemory($start_memory);
        $this->point_memory_last = $this->data['memory_start'];

        if ($this->config->debug_on_error) {
            // Установливаем уровень перехвата ошибок и свои обработчики ошибок
            if ($this->config->error_strict) { error_reporting (E_ALL | E_STRICT); }
            $old_error_handler = set_error_handler(array($this, 'catchError'));
            register_shutdown_function(array($this, 'catchFatal'));
            // Включаем/выключаем вывод ошибок на экран
            ini_set('display_errors', ($this->config->error_display ? 'On' : 'Off'));
        }

        // Сохраняем первые значения времени и памяти отладки
        $this->debug_time = microtime(true) - $this->time_start;
        $this->debug_memory = memory_get_usage(false) - $start_data['memory'];
    }

    public function __clone() {}

    public static function getInstance($params='', $start_data='') {
        if (self::$instance === null) { self::$instance = new self($params, $start_data); }
        return self::$instance;
    }

    public function __get($name) {
        return (isset($this->data[$name]) ? $this->data[$name] : false );
    }

    public static function get($key) {
        return self::getInstance()->$key;
    }


// == DB Connects ==============================================================

    // -------------------------------------------------------------------------
    /**
    * Запоминает время начала соединения к БД
    * Вставляется непосредственно перед началом соединения
    */
    public function beginConnect() {
        $this->sql_time_start = microtime(true);
        return true;
    }

    // -------------------------------------------------------------------------
    /**
    * Подсчитывает и сохраняет замеры runtime соединений с БД
    * Вставляется непосредственно после всех операторов соединения
    * @param str $params Массив параметров соединения для лога
    */
    public function endConnect($params='') {

        $this->startDebugRuntime();

        // Сохраняем runtime
        $rt = $this->debug_time_start - $this->sql_time_start;
        $this->sql_time_connect += $rt;
        $this->data['sql_time_connect'] = $this->roundTime($this->sql_time_connect);
        $this->data['sql_time'] = $this->data['sql_time_connect'] + $this->data['sql_time_query'];
        $this->data['sql_count_connect']++;

        // Выход, если отладка SQL запрещена
        if (!$this->config->debug_on_sql && !$this->point_debug_on_sql) {
            $this->updateDebugRuntime(true);
            return true;
        }

        // Выход, если включены фильтры для SQL
        if ($this->config->filter_query_sql <> '' || $this->config->filter_query_from <> '') {
            $this->updateDebugRuntime(true);
            return true;
        }

        // Трассировка вызовов. Задаём пропуск вызовов из cmsDatabase
        $trace = $this->getTrace($this->config->trace_level_sql+1, 1);

        // Добавляем строку лога
        $this->debug_html .= '<div class="debug_row">'.
            '<span class="connect">Connect '.$this->data['sql_count_connect'].'</span> - <strong>'.$this->roundTime($rt).'</strong> ms - '.
            $this->getHtmlLogScriptTime($this->debug_time_start).
            ' <tt>&nbsp;&nbsp; '.$trace['point'].'</tt><br/>'.
            '<pre class="params"><span class="help" title="Host of SQL-server">'.$params['db_host'].'</span> → <span class="help" title="Database">'.$params['db_base'].'</span> → <span class="help" title="Username">'.$params['db_user'].'</span></pre>'.
            $trace['html']."</div>\n\n";

        $this->updateDebugRuntime(true);

        return true;
    }


//== DB Queries ================================================================

    // -------------------------------------------------------------------------
    /**
    * Запоминает время начала запроса к БД
    * Вставляется непосредственно перед запросом mysql_query
    */
    public function beginQuery() {
        $this->sql_time_start = microtime(true);
        return true;
    }

    // -------------------------------------------------------------------------
    /**
    * Подсчитывает и сохраняет замеры runtime запроса
    * Вставляется непосредственно после запроса mysql_query
    * @param string $sql Строка запроса для лога, выводится без изменений
    * @param object $result Результат выполнения SQL-запроса
    * @param array $info Массив с информацией о работе запроса
    */
    public function endQuery($sql='', $result='', $info) {

        $this->startDebugRuntime();

        // Сохраняем runtime
        $rt = $this->debug_time_start - $this->sql_time_start;
        $this->sql_time_query += $rt;
        $this->data['sql_time_query'] = $this->roundTime($this->sql_time_query);
        $this->data['sql_time'] = $this->data['sql_time_connect'] + $this->data['sql_time_query'];
        $this->data['sql_count_query']++;

        // Считаем ошибки и предупреждения
        if ($info['errno'] > 0) { $this->data['sql_errors']++; }
        if ($info['warnings']) { $this->data['sql_warnings']++; }

        // Выход, если отладка SQL запрещена
        if (!$this->config->debug_on_sql && !$this->point_debug_on_sql) {
            $this->updateDebugRuntime(true);
            return true;
        }

        // Выход, если не удовлетворяет фильтру по SQL-строке запроса
        if ($this->config->filter_query_sql <> '') {

            $this->sql_filter_on = true;

            if ( mb_stripos( mb_ereg_replace('\s+', ' ', trim($sql)), mb_ereg_replace('\s+', ' ', $this->config->filter_query_sql) ) === false ) {
                $this->updateDebugRuntime(true);
                return true;
            } else {
                $sql = $this->highliteStr($this->config->filter_query_sql, $sql);
            }
        }

        // Трассировка вызовов. Задаём пропуск вызовов из cmsDatabase
        $trace = $this->getTrace($this->config->trace_level_sql+2, 2);

        // Выход, если не удовлетворяет фильтру по пути/имени вызывающего файла
        if ($this->config->filter_query_from <> '') {

            $this->sql_filter_on = true;

            $filter = $this->filterFrom($this->config->filter_query_from, $trace);

            if ($filter['result']) {
                $trace = $filter['trace'];
            } else {
                $this->updateDebugRuntime(true);
                return true;
            }
        }

        // Получаем результат запроса в виде массива, если нужно и возможно
        if ($this->config->query_log_data && $result) {
            $result_array = $this->getQueryRows($result);
        } else {
            $result_array = false;
        }

        // Считаем отфильтрованные строки
        if ($this->sql_filter_on) { $this->data['sql_filter_count']++; }

        $sql = self::highliteSql($sql);

        // Добавляем строку лога
        $this->debug_html .= '<div class="debug_row'.($this->config->query_heavy && ($rt*1000 > $this->config->query_heavy) ? ' heavy' : '').'">'.
            '<span class="query">Query '.$this->data['sql_count_query'].'</span> - <strong>'.$this->roundTime($rt).'</strong> ms - '.
            $this->getHtmlLogScriptTime($this->debug_time_start).
            ' <tt>&nbsp;&nbsp; '.$trace['point'].'&nbsp;&nbsp;</tt> '.
            'Affected/returned rows: <strong>'.$info['affected_rows'].'</strong>&nbsp;&nbsp;'.$info['info'];

        if ($info['errno'] > 0) { $this->debug_html .= "<br>\n<span class=\"error\">Error ".$info['errno'].': '.$info['error'].'</span>'; }

        if ($info['warnings']) { $this->debug_html .= '<span class="warning">'.$info['warnings'].'</span>'; }

        $this->debug_html .= '<br><pre class="sql_text">'.$sql.'</pre>';
        $this->debug_html .= $trace['html'];

        if ($result_array) { $this->debug_html .= '<br/>Result:<br/>'.self::var_dump_color($result_array); }

        $this->debug_html .= "</div>\n\n";

        $this->updateDebugRuntime(true);

        return true;
    }


//== Autoloads =================================================================

    // -------------------------------------------------------------------------
    /**
    * Запоминает время начала автозагрузки
    * Вставляется перед инклудом в автозагрузке
    */
    public function beginAutoload() {
        $this->auto_time_start = microtime(true);
        return true;
    }

    // -------------------------------------------------------------------------
    /**
    * Подсчитывает и сохраняет замеры runtime автозагрузки
    * Вставляется после инклуда в автозагрузке
    * @param string $class Класс для автозагрузки
    * @param string $file Путь к подключаемому файлу
    * @param mixed $result Результат попытки автозагрузки
    */
    public function endAutoload($class='', $file='', $result='') {

        $this->startDebugRuntime();

        // Сохраняем runtime
        $rt = $this->debug_time_start - $this->auto_time_start;
        $this->auto_time += $rt;
        $this->data['auto_time'] = $this->roundTime($this->auto_time);
        $this->data['auto_count']++;

        // Выход, если отладка автозагрузки запрещена
        if (!$this->config->debug_on_auto && !$this->point_debug_on_include) {
            $this->updateDebugRuntime(true);
            return true;
        }

        // Подготавливаем путь
        if ($file) { $file = '/'.$file; }

        // Выход, если не удовлетворяет фильтру по пути/имени подключаемого файла
        if ($this->config->filter_auto_file <> '') {

            $this->auto_filter_on = true;

            if (mb_stripos($file, $this->config->filter_auto_file) === false) {
                $this->updateDebugRuntime(true);
                return true;
            } else {
                $file = $this->highliteStr($this->config->filter_auto_file, $file);
            }
        }

        // Трассировка вызовов. Задаём пропуск вызовов из autoload.php
        $trace = $this->getTrace($this->config->trace_level_auto+2, 2);

        // Выход, если не удовлетворяет фильтру по пути/имени подключающего файла
        if ($this->config->filter_auto_from <> '') {

            $this->auto_filter_on = true;
            $filter = $this->filterFrom($this->config->filter_auto_from, $trace);

            if ($filter['result']) {
                $trace = $filter['trace'];
            } else {
                $this->updateDebugRuntime(true);
                return true;
            }
        }

        // Считаем отфильтрованные строки
        if ($this->auto_filter_on) { $this->data['auto_filter_count']++; }

        // Добавляем строку лога
        $this->debug_html .= '<div class="debug_row">'.
            '<span class="auto">Autoload '.$this->data['auto_count'].'</span> - <strong>'.$this->roundTime($rt).'</strong> ms - '.
            $this->getHtmlLogScriptTime($this->debug_time_start).
            ' <tt>&nbsp;&nbsp; '.$trace['point'].'&nbsp;&nbsp;</tt> '.
            'Result: '.($result==1 ? '<span class="ok">OK</span>' : '<span class="error">'.$result.'</span>').'<br/>'.
            '<pre class="params">'.$class.($file ? '  -  '.$file : '').'</pre>'.
            $trace['html']."</div>\n\n";

        $this->updateDebugRuntime(true);

        return true;
    }


//== Includes ==================================================================

    // -------------------------------------------------------------------------
    /**
    * Запоминает время начала инклуда
    * Вставляется перед инклудом
    */
    public function beginInclude() {
        $this->include_time_start = microtime(true);
        return true;
    }

    // -------------------------------------------------------------------------
    /**
    * Подсчитывает и сохраняет замеры runtime инклуда
    * Вставляется после инклуда
    * @param string $file   Путь к подключаемому файлу
    * @param int    $code   Код ошибки
    * @param mixed   $result Результат попытки инклуда
    */
    public function endInclude($file='', $code=0, $result='') {

        $this->startDebugRuntime();

        // Сохраняем runtime
        $rt = $this->debug_time_start - $this->include_time_start;
        $this->include_time += $rt;
        $this->data['include_time'] = $this->roundTime($this->include_time);
        $this->data['include_count']++;

        // Выход, если отладка инклуда запрещена
        if (!$this->config->debug_on_include && !$this->point_debug_on_include) {
            $this->updateDebugRuntime(true);
            return true;
        }

        // Подготавливаем путь
        $root_path = cmsConfig::getInstance()->root_path;
        if (substr($file, 0, strlen($root_path)) == $root_path) { $file = substr($file, strlen($root_path)-1); }

        // Выход, если не удовлетворяет фильтру по пути/имени подключаемого файла
        if ($this->config->filter_include_file <> '') {

            $this->include_filter_on = true;

            if (mb_stripos($file, $this->config->filter_include_file) === false) {
                $this->updateDebugRuntime(true);
                return true;
            } else {
                $file = $this->highliteStr($this->config->filter_include_file, $file);
            }
        }

        // Трассировка вызовов. Задаём пропуск вызовов из includeFile()
        $trace = $this->getTrace($this->config->trace_level_include+1, 1);

        // Выход, если не удовлетворяет фильтру по пути/имени подключающего файла
        if ($this->config->filter_include_from <> '') {

            $this->include_filter_on = true;
            $filter = $this->filterFrom($this->config->filter_include_from, $trace);

            if ($filter['result']) {
                $trace = $filter['trace'];
            } else {
                $this->updateDebugRuntime(true);
                return true;
            }
        }

        // Сохраняем данные для таблицы количеств инклудов
        if ($file) {

            // Считаем количества
            if (array_key_exists($file, $this->includes)) {
                $this->includes[$file]['count']++;
                $this->includes[$file]['time'] += $this->roundTime($rt);
            } else {
                $this->includes[$file]['count'] = 1;
                $this->includes[$file]['time']  = $this->roundTime($rt);
                $this->includes[$file]['error'] = 0;
            }

            // Считаем ошибки
            $result_bool = ( $code == self::INCLUDE_OK || $code == self::INCLUDE_ALREADY );
            if ($code == self::INCLUDE_NOT_FOUND) { $this->includes[$file]['error']++; }
        }

        // Считаем отфильтрованные строки
        if ($this->include_filter_on) { $this->data['include_filter_count']++; }

        // Добавляем строку лога
        $this->debug_html .= '<div class="debug_row">'.
            '<span class="include">Include '.$this->data['include_count'].'</span> - '.
            '<strong>'.$this->roundTime($rt).'</strong> ms - '.
            $this->getHtmlLogScriptTime($this->debug_time_start).
            ' <tt>&nbsp;&nbsp; '.$trace['point'].'&nbsp;&nbsp;</tt> '.
            'Result: <span class="'.$this->include_codes_css[$code].'">'.$this->include_codes[$code].'</span><br/>'.
            '<pre class="params">'.$file.'</pre>'.
            $trace['html']."</div>\n\n";

        $this->updateDebugRuntime(true);

        return true;
    }


//== Events & Hooks ============================================================

    // -------------------------------------------------------------------------
    /**
    * Фиксирует произошедшие события (перед вызовом хуков)
    * @param string $event_name  Событие
    * @param mixed $data          Данные, передаваемые в хук
    */
    public function logEvent($event_name='', $data=false) {

        $this->startDebugRuntime();

        // Сохраняем количество событий
        $this->data['hook_events']++;

        // Выход, если отладка хуков запрещена
        if (!$this->config->debug_on_hook) {
            $this->updateDebugRuntime();
            return true;
        }

        // Выход, если не удовлетворяет фильтру по событию
        $event_name_h = $event_name;

        if ($this->config->filter_hook_event_str <> '') {

            if (stripos($event_name, $this->config->filter_hook_event_str) === false) {
                $this->updateDebugRuntime();
                return true;
            }

            $event_name_h = $this->highliteStr($this->config->filter_hook_event_str, $event_name);

        } else if ($this->config->filter_hook_event <> 'none') {

            if ($event_name != $this->config->filter_hook_event) {
                $this->updateDebugRuntime();
                return true;
            }

            $event_name_h = $this->highliteStr($this->config->filter_hook_event, $event_name);
        }

        // Трассировка вызовов. Задаём пропуск вызовов из debug.php
        $trace = $this->getTrace($this->config->trace_level_hook+1, 1);

        // Выход, если не удовлетворяет фильтру по пути/имени подключающего файла
        if ($this->config->filter_hook_from <> '') {

            $filter = $this->filterFrom($this->config->filter_hook_from, $trace);

            if ($filter['result']) {
                $trace = $filter['trace'];
            } else {
                $this->updateDebugRuntime(true);
                return true;
            }
        }

        // Сохраняем данные для таблицы количеств событий
        if (isset($this->events[$event_name]) && array_key_exists($event_name, $this->events)) {
            $this->events[$event_name] ++;
        } else {
            $this->events[$event_name] = 1;
        }

        // Считаем отфильтрованные строки
        $this->data['hook_filter_events']++;

        // Добавляем строку лога
        $this->debug_html .= '<div class="debug_row">'.
            '<span class="event">Event '.$this->data['hook_events'].'&nbsp;&nbsp;\'<strong><tt>'.$event_name_h.'</tt></strong>\'</span> - '.
            $this->getHtmlLogScriptTime($this->debug_time_start).
            ' <tt>&nbsp;&nbsp; '.$trace['point'].'&nbsp;&nbsp;</tt>'.
            $trace['html'];

        if ($this->config->hook_log_data) {
            $this->debug_html .= ( $data ? '<br/>Data:<br/>'.self::var_dump_color($data) : '' );
        }

        $this->debug_html .= "</div>\n\n";

        $this->updateDebugRuntime();

        return true;
    }

    // -------------------------------------------------------------------------
    /**
    * Запоминает время начала хука
    * Вставляется перед хуком
    */
    public function beginHook() {

        $this->hook_time_start = microtime(true);
        $this->hook_memory_start = memory_get_usage($this->config->memory_real_usage);
        $this->hook_memory_peak = memory_get_peak_usage($this->config->memory_real_usage);
        $this->hook_sql_time  = $this->data['sql_time_connect'] + $this->data['sql_time_query'];
        $this->hook_sql_count = $this->data['sql_count_connect'] + $this->data['sql_count_query'];
        $this->hook_include_time = $this->data['auto_time'] + $this->data['include_time'];
        $this->hook_include_count = $this->data['auto_count'] + $this->data['include_count'];

        return true;
    }

    // -------------------------------------------------------------------------
    /**
    * Подсчитывает и сохраняет замеры runtime хука
    * Вставляется после хука
    * @param string $event_name  Событие
    * @param mixed $data          Данные, передаваемые в хук
    * @param mixed $result        Результат, возвращаемый хуком
    */
    public function endHook($event_name='', $listener='', $data=false, $result=false) {
        $this->startDebugRuntime();

        // Считаем использованную память
        $mem = $this->calcMemory($this->hook_memory_start, $this->hook_memory_peak);

        // Сохраняем runtime
        $rt = $this->debug_time_start - $this->hook_time_start;
        $this->hook_time += $rt;
        $this->data['hook_time'] = $this->roundTime($this->hook_time);
        $this->data['hook_count']++;
        $this->data['hook_memory'] += $this->roundMemory($mem['memory']);

        // Обнуляем время - признак того, что никакой хук уже не обсчитывается
        $this->hook_time_start = 0;

        // Выход, если отладка хуков запрещена
        if (!$this->config->debug_on_hook) {
            $this->updateDebugRuntime();
            return true;
        }

        // Выход, если не удовлетворяет фильтру по событию
        $event_name_h = $event_name;

        if ($this->config->filter_hook_event_str <> '') {

            if (stripos($event_name, $this->config->filter_hook_event_str) === false) {
                $this->updateDebugRuntime();
                return true;
            }

            $event_name_h = $this->highliteStr($this->config->filter_hook_event_str, $event_name);

        } else if ($this->config->filter_hook_event <> 'none') {

            if ($event_name != $this->config->filter_hook_event) {
                $this->updateDebugRuntime();
                return true;
            }

            $event_name_h = $this->highliteStr($this->config->filter_hook_event, $event_name);
        }

        // Выход, если не удовлетворяет фильтру по контроллеру
        $listener_h = $listener;

        if ($this->config->filter_hook_control <> 'none') {

            if ($listener != $this->config->filter_hook_control) {
                $this->updateDebugRuntime();
                return true;
            }

            $listener_h = $this->highliteStr($this->config->filter_hook_control, $listener);
        }

        // Трассировка вызовов. Задаём пропуск вызовов из debug.php
        $trace = $this->getTrace($this->config->trace_level_hook+1, 1);

        // Выход, если не удовлетворяет фильтру по пути/имени подключающего файла
        if ($this->config->filter_hook_from <> '') {

            $filter = $this->filterFrom($this->config->filter_hook_from, $trace);

            if ($filter['result']) {
                $trace = $filter['trace'];
            } else {
                $this->updateDebugRuntime(true);
                return true;
            }
        }

        // Количество и время SQL
        $sql_time  = $this->data['sql_time_connect'] + $this->data['sql_time_query'] - $this->hook_sql_time;
        $sql_count = $this->data['sql_count_connect'] + $this->data['sql_count_query'] - $this->hook_sql_count;

        // Количество и время автозагрузок и инклудов
        $include_count = $this->data['auto_count'] + $this->data['include_count'] - $this->hook_include_count;
        $include_time  = $this->data['auto_time'] + $this->data['include_time'] - $this->hook_include_time;

        // Сохраняем данные для таблицы количеств хуков
        if (isset($this->hooks[$event_name][$listener]) && array_key_exists($listener, $this->hooks[$event_name])) {
            $this->hooks[$event_name][$listener]['count'] ++;
            $this->hooks[$event_name][$listener]['time'] += $this->roundTime($rt);
        } else {
            $this->hooks[$event_name][$listener]['count'] = 1;
            $this->hooks[$event_name][$listener]['time'] = $this->roundTime($rt);
        }

        // Считаем отфильтрованные строки
        $this->data['hook_filter_count']++;

        // Добавляем строку лога
        $this->debug_html .= '<div class="debug_row'.($this->config->hook_heavy && ($rt*1000 > $this->config->hook_heavy) ? ' heavy' : '').'">'.
            '<span class="hook">Hook '.$this->data['hook_count'].'&nbsp;&nbsp;\''.
            '<strong><tt><span class="event help" title="Event">'.$event_name_h.'</span> → '.
            '<span class="help" title="Controller">'.$listener_h.'</span></tt></strong>\'</span> - '.
            '<strong>'.$this->roundTime($rt).'</strong> ms - '.
            $this->getHtmlLogScriptTime($this->debug_time_start).
            $this->getHtmlLogSql($sql_count, $sql_time).
            $this->getHtmlLogInclude($include_count, $include_time).
            $this->getHtmlLogMemory($mem['memory'], $mem['type']).
            ' <tt>&nbsp;&nbsp; '.$trace['point'].'&nbsp;&nbsp;</tt>'.
            $trace['html'];

        if ($this->config->hook_log_data) {
            $this->debug_html .= ($data ? '<br/>Data:<br/>'.self::var_dump_color($data) : '');
            $this->debug_html .= ($result ? '<br/>Result:<br/>'.self::var_dump_color($result) : '');
        }

        $this->debug_html .= "</div>\n\n";

        $this->updateDebugRuntime();

        return true;
    }


//== Widgets ===================================================================

    // -------------------------------------------------------------------------
    /**
    * Запоминает время старта виджета
    * Вставляется перед виджетом
    */
    public function beginWidget($widget=false) {

        $this->startDebugRuntime();

        $this->widget_time_start = microtime(true);
        $this->widget_memory_start = memory_get_usage($this->config->memory_real_usage);
        $this->widget_memory_peak = memory_get_peak_usage($this->config->memory_real_usage);
        $this->widget_sql_time =  $this->data['sql_time_connect'] + $this->data['sql_time_query'];
        $this->widget_sql_count = $this->data['sql_count_connect'] + $this->data['sql_count_query'];
        $this->widget_include_time = $this->data['auto_time'] + $this->data['include_time'];
        $this->widget_include_count = $this->data['auto_count'] + $this->data['include_count'];
        $this->widget_hook_time = $this->data['hook_time'];
        $this->widget_hook_count = $this->data['hook_count'];
        $this->widget_hook_events = $this->data['hook_events'];
        $this->data['widget_count']++;

        // Выход, если отладка виджетов запрещена
        if (!$this->config->debug_on_widget) {
            $this->updateDebugRuntime();
            return true;
        }

        // Получаем имя виджета и контроллера
        $widget_name = '';
        if ($widget && array_key_exists('name', $widget)) { $widget_name = $widget['name']; }
        $controller = '';
        if ($widget && array_key_exists('controller', $widget)) { $controller = $widget['controller']; }

        // Выход, если не удовлетворяет фильтру по имени виджета
        $widget_name_h = $widget_name;

        if ($this->config->filter_widget_widget <> 'none') {

            if ($widget_name != $this->config->filter_widget_widget) {
                $this->updateDebugRuntime();
                return true;
            }

            $widget_name_h = $this->highliteStr($this->config->filter_widget_widget, $widget_name);
        }

        // Выход, если не удовлетворяет фильтру по контроллеру
        $controller_h = $controller;

        if ($this->config->filter_widget_control <> 'none') {

            if ($controller != $this->config->filter_widget_control) {
                $this->updateDebugRuntime();
                return true;
            }

            $controller_h = $this->highliteStr($this->config->filter_widget_control, $controller);
        }

        // Трассировка вызовов. Задаём пропуск вызовов из debug.php
        $trace = $this->getTrace($this->config->trace_level_widget+1, 1);

        // Добавляем строку лога
        $this->debug_html .= '<div class="debug_row">'.
            '<span class="widget">Widget '.$this->data['widget_count'].'&nbsp;&nbsp;'.
            '\'<strong><tt>'.($controller ? '<span class="help" title="Controller">'.$controller_h.'</span> → ' : '').
            '<span class="help" title="Widget">'.$widget_name_h.'</span></tt></strong>\'&nbsp;&nbsp;start</span> - '.
            $this->getHtmlLogScriptTime($this->debug_time_start).
            ' <tt>&nbsp;&nbsp; '.$trace['point'].'</tt>'.
            $trace['html']."</div>\n\n";

        $this->updateDebugRuntime();

        return true;
    }

    // -------------------------------------------------------------------------
    /**
    * Запоминает время старта рендеринга виджета
    * Вставляется перед вызовом рендеринга виджетом
    */
    public function renderWidget() {
        $this->widget_time_render = microtime(true);
        return true;
    }

    // -------------------------------------------------------------------------
    /**
    * Подсчитывает и сохраняет замеры runtime виджета
    * Вставляется после вызова виджета
    * @param array  $widget  Массив данных виджета
    * @param mixed   $result  Результат, возвращаемый виджетом или Причина ошибки
    */
    public function endWidget($widget=false, $rendered=false, $result=false) {

        $this->startDebugRuntime();

        // Считаем использованную память
        $mem = $this->calcMemory($this->widget_memory_start, $this->widget_memory_peak);

        // Сохраняем runtime
        $rt = $this->debug_time_start - $this->widget_time_start;
        $this->widget_time += $rt;
        $this->data['widget_time'] = $this->roundTime($this->widget_time);
        $this->data['widget_memory'] += $this->roundMemory($mem['memory']);

        // Считаем время обработки данных виджета и рендеринга
        if ($this->widget_time_render) {
            $rt_data   = $this->widget_time_render - $this->widget_time_start;
            $rt_render = $rt - $rt_data;
        } else {
            $rt_data   = $rt;
            $rt_render = 0;
        }

        // Обнуляем время - признак того, что никакой виджет уже не обсчитывается
        $this->widget_time_start = 0;
        $this->widget_time_render = 0;

        // Выход, если отладка виджетов запрещена
        if (!$this->config->debug_on_widget) {
            $this->updateDebugRuntime();
            return true;
        }

        // Получаем имя виджета и контроллера
        $widget_name = '';
        if ($widget && array_key_exists('name', $widget)) { $widget_name = $widget['name']; }
        $controller = '';
        if ($widget && array_key_exists('controller', $widget)) { $controller = $widget['controller']; }

        // Выход, если не удовлетворяет фильтру по имени виджета
        $widget_name_h = $widget_name;

        if ($this->config->filter_widget_widget <> 'none') {

            if ($widget_name != $this->config->filter_widget_widget) {
                $this->updateDebugRuntime();
                return true;
            }

            $widget_name_h = $this->highliteStr($this->config->filter_widget_widget, $widget_name);
        }

        // Выход, если не удовлетворяет фильтру по контроллеру
        $controller_h = $controller;

        if ($this->config->filter_widget_control <> 'none') {

            if ($controller != $this->config->filter_widget_control) {
              $this->updateDebugRuntime();
              return true;
            }

            $controller_h = $this->highliteStr($this->config->filter_widget_control, $controller);
        }

        // Количество и время SQL
        $sql_time  = $this->data['sql_time_connect'] + $this->data['sql_time_query'] - $this->widget_sql_time;
        $sql_count = $this->data['sql_count_connect'] + $this->data['sql_count_query'] - $this->widget_sql_count;

        // Количество и время автозагрузок и инклудов
        $include_count = $this->data['auto_count'] + $this->data['include_count'] - $this->widget_include_count;
        $include_time  = $this->data['auto_time'] + $this->data['include_time'] - $this->widget_include_time;

        // Количество и время хуков и событий
        $hook_count  = $this->data['hook_count'] - $this->widget_hook_count;
        $hook_time   = $this->data['hook_time'] - $this->widget_hook_time;
        $hook_events = $this->data['hook_events'] - $this->widget_hook_events;

        // Трассировка вызовов. Задаём пропуск вызовов из debug.php
        $trace = $this->getTrace($this->config->trace_level_widget+1, 1);

        // Сохраняем данные для таблицы виджетов
        if (isset($this->widgets[$controller][$widget_name]) && array_key_exists($widget_name, $this->widgets[$controller])) {
            $this->widgets[$controller][$widget_name]['count'] ++;
            $this->widgets[$controller][$widget_name]['time'] += $this->roundTime($rt);
        } else {
            $this->widgets[$controller][$widget_name]['count'] = 1;
            $this->widgets[$controller][$widget_name]['time'] = $this->roundTime($rt);
        }

        // Считаем отфильтрованные строки
        $this->data['widget_filter_count']++;

        // Добавляем строку лога
        $this->debug_html .= '<div class="debug_row'.($this->config->widget_heavy && ($rt*1000 > $this->config->widget_heavy) ? ' heavy' : '').'">'.
            '<span class="widget">Widget '.$this->data['widget_count'].'&nbsp;&nbsp;'.
            '\'<strong><tt>'.($controller ? '<span class="help" title="Controller">'.$controller_h.'</span> → ' : '').
            '<span class="help" title="Widget">'.$widget_name_h.'</span></tt></strong>\'&nbsp;&nbsp;end</span> - '.
            '<span class="help" title="Full time of the widget"><strong>'.$this->roundTime($rt).'</strong></span> ms </strong>'.
            '( <span class="help" title="Time of the getting widget data"><strong>'.$this->roundTime($rt_data).'</strong></span> + '.
            '<span class="help" title="Time of the rendering widget">'.$this->strongNotNull($rt_render, $this->roundTime($rt_render)).'</span> ms ) - '.
            $this->getHtmlLogScriptTime($this->debug_time_start).
            $this->getHtmlLogSql($sql_count, $sql_time).
            $this->getHtmlLogInclude($include_count, $include_time).
            $this->getHtmlLogEventHook($hook_events, $hook_count, $hook_time).
            $this->getHtmlLogMemory($mem['memory'], $mem['type']).
            '&nbsp;&nbsp; '.($rendered ? 'Rendered' : 'Not rendered: '.$result);

        if ($this->config->widget_log_data) {
            $this->debug_html .= ($widget ? '<br/>Data:<br/>'.self::var_dump_color($widget) : '');
            $this->debug_html .= ($rendered && $result ? '<br/>Result:<br/>'.self::var_dump_color($result) : '');
        }

        $this->debug_html .= "</div>\n\n";

        $this->updateDebugRuntime();

        return true;
    }


//== Controller ================================================================

    // -------------------------------------------------------------------------
    /**
    * Запоминает время начала старта контроллера
    * Вставляется непосредственно перед стартом контроллера
    */
    public function beginController() {

        $this->startDebugRuntime();

        $this->control_time_start = microtime(true);
        $this->control_memory_start = memory_get_usage($this->config->memory_real_usage);
        $this->control_memory_peak = memory_get_peak_usage($this->config->memory_real_usage);
        $this->control_sql_time  = $this->data['sql_time_connect'] + $this->data['sql_time_query'];
        $this->control_sql_count = $this->data['sql_count_connect'] + $this->data['sql_count_query'];
        $this->control_include_time = $this->data['auto_time'] + $this->data['include_time'];
        $this->control_include_count = $this->data['auto_count'] + $this->data['include_count'];
        $this->control_hook_time = $this->data['hook_time'];
        $this->control_hook_count = $this->data['hook_count'];
        $this->control_hook_events = $this->data['hook_events'];
        $this->data['control_count']++;

        // Выход, если отладка контроллера запрещена
        if (!$this->config->debug_on_controller) {
            $this->updateDebugRuntime();
            return true;
        }

        // Трассировка вызовов. Задаём пропуск вызовов из debug.php
        $trace = $this->getTrace(2, 1);

        // Добавляем строку лога
        $this->debug_html .= '<div class="debug_row">'.
            '<span class="control">Controller '.$this->data['control_count'].'&nbsp;&nbsp;start</span> - '.
            $this->getHtmlLogScriptTime($this->debug_time_start).
            ' <tt>&nbsp;&nbsp; '.$trace['point'].'</tt>';

        $this->debug_html .= "</div>\n\n";

        $this->updateDebugRuntime();

        return true;
    }

    // -------------------------------------------------------------------------
    /**
    * Подсчитывает и сохраняет время работы контроллера
    * Вставляется непосредственно после отработки контроллера
    */
    public function endController() {

        $this->startDebugRuntime();

        // Считаем использованную память
        $mem = $this->calcMemory($this->control_memory_start, $this->control_memory_peak);

        // Сохраняем runtime и память
        $rt = $this->roundTime($this->debug_time_start - $this->control_time_start);
        $this->data['control_time'] += $rt;
        $this->data['control_memory'] += $this->roundMemory($mem['memory']);
        $this->data['control_memory_type'] = $mem['type'];

        // Обнуляем время - признак того, что контроллер уже не обсчитывается
        $this->control_time_start = 0;

        // Выход, если отладка контроллера запрещена
        if (!$this->config->debug_on_controller) {
            $this->updateDebugRuntime();
            return true;
        }

        // Количество и время SQL
        $sql_time  = $this->data['sql_time_connect'] + $this->data['sql_time_query'] - $this->control_sql_time;
        $sql_count = $this->data['sql_count_connect'] + $this->data['sql_count_query'] - $this->control_sql_count;

        // Количество и время автозагрузок и инклудов
        $include_count = $this->data['auto_count'] + $this->data['include_count'] - $this->control_include_count;
        $include_time  = $this->data['auto_time'] + $this->data['include_time'] - $this->control_include_time;

        // Количество и время хуков и событий
        $hook_count  = $this->data['hook_count'] - $this->control_hook_count;
        $hook_time   = $this->data['hook_time'] - $this->control_hook_time;
        $hook_events = $this->data['hook_events'] - $this->control_hook_events;

        // Трассировка вызовов. Задаём пропуск вызовов из debug.php
        $trace = $this->getTrace(2, 1);

        // Добавляем строку лога
        $this->debug_html .= '<div class="debug_row">'.
            '<span class="control">Controller '.$this->data['control_count'].' \'<strong>'.cmsCore::getInstance()->controller.'</strong>\'&nbsp;&nbsp;end</span> - '.
            '<strong>'.$rt.'</strong> ms - '.
            $this->getHtmlLogScriptTime($this->debug_time_start).
            $this->getHtmlLogSql($sql_count, $sql_time).
            $this->getHtmlLogInclude($include_count, $include_time).
            $this->getHtmlLogEventHook($hook_events, $hook_count, $hook_time).
            $this->getHtmlLogMemory($mem['memory'], $mem['type']);
        $this->debug_html .= "</div>\n\n";

        $this->updateDebugRuntime();

        return true;
    }


//== Template ==================================================================

    // -------------------------------------------------------------------------
    /**
    * Запоминает время начала отрисовки страницы
    * Вставляется непосредственно перед началом рендеринга
    * @param string $template_name  Имя шаблона
    */
    public function beginTemplate($template_name='') {

        $this->startDebugRuntime();

        // Сохраняем runtime
        $this->template_time_start = microtime(true);
        $this->template_memory_start = memory_get_usage($this->config->memory_real_usage);
        $this->template_memory_peak = memory_get_peak_usage($this->config->memory_real_usage);
        $this->template_sql_time  = $this->data['sql_time_connect'] + $this->data['sql_time_query'];
        $this->template_sql_count = $this->data['sql_count_connect'] + $this->data['sql_count_query'];
        $this->template_include_time = $this->data['auto_time'] + $this->data['include_time'];
        $this->template_include_count = $this->data['auto_count'] + $this->data['include_count'];
        $this->template_hook_time = $this->data['hook_time'];
        $this->template_hook_count = $this->data['hook_count'];
        $this->template_hook_events = $this->data['hook_events'];
        $this->data['template_count']++;

        // Выход, если отладка рендеринга запрещена
        if (!$this->config->debug_on_template) {
            $this->updateDebugRuntime();
            return true;
        }

        // Трассировка вызовов. Задаём пропуск вызовов из debug.php
        $trace = $this->getTrace(2, 2);

        // Добавляем строку лога
        $this->debug_html .= '<div class="debug_row">'.
            '<span class="template">Template init '.$this->data['template_count'].'&nbsp;&nbsp;'.
            ($template_name ? '\'<strong><tt>'.$template_name.'</tt></strong>\'&nbsp;&nbsp;' : '').'start</span> - '.
            $this->getHtmlLogScriptTime($this->debug_time_start).
            ' <tt>&nbsp;&nbsp; '.$trace['point'].'</tt>';

        $this->debug_html .= "</div>\n\n";

        $this->updateDebugRuntime();

        return true;
    }

    // -------------------------------------------------------------------------
    /**
    * Подсчитывает и сохраняет время отрисовки страницы
    * Вставляется непосредственно после ренедеринга страницы
    * @param string $template_name  Имя шаблона
    */
    public function endTemplate($template_name='') {

        $this->startDebugRuntime();

        // Считаем использованную память
        $mem = $this->calcMemory($this->template_memory_start, $this->template_memory_peak);

        // Сохраняем runtime
        $rt = $this->roundTime($this->debug_time_start - $this->template_time_start);
        $this->data['template_time'] += $rt;
        $this->data['template_memory'] += $this->roundMemory($mem['memory']);
        $this->data['template_memory_type'] = $mem['type'];

        // Обнуляем время - признак того, что рендеринг уже не обсчитывается
        $this->template_time_start = 0;

        // Выход, если отладка рендеринга запрещена
        if (!$this->config->debug_on_template) {
            $this->updateDebugRuntime();
            return true;
        }

        // Количество и время SQL
        $sql_time  = $this->data['sql_time_connect'] + $this->data['sql_time_query'] - $this->template_sql_time;
        $sql_count = $this->data['sql_count_connect'] + $this->data['sql_count_query'] - $this->template_sql_count;

        // Количество и время автозагрузок и инклудов
        $include_count = $this->data['auto_count'] + $this->data['include_count'] - $this->template_include_count;
        $include_time  = $this->data['auto_time'] + $this->data['include_time'] - $this->template_include_time;

        // Количество и время хуков и событий
        $hook_count  = $this->data['hook_count'] - $this->template_hook_count;
        $hook_time   = $this->data['hook_time'] - $this->template_hook_time;
        $hook_events = $this->data['hook_events'] - $this->template_hook_events;

        // Трассировка вызовов. Задаём пропуск вызовов из debug.php
        $trace = $this->getTrace(2, 1);

        // Добавляем строку лога
        $this->debug_html .= '<div class="debug_row">'.
            '<span class="template">Template init '.$this->data['template_count'].'&nbsp;&nbsp;'.
            ($template_name ? '\'<strong><tt>'.$template_name.'</tt></strong>\'&nbsp;&nbsp;' : '').'end</span> - '.
            '<strong>'.$rt.'</strong> ms - '.
            $this->getHtmlLogScriptTime($this->debug_time_start).
            $this->getHtmlLogSql($sql_count, $sql_time).
            $this->getHtmlLogInclude($include_count, $include_time).
            $this->getHtmlLogEventHook($hook_events, $hook_count, $hook_time).
            $this->getHtmlLogMemory($mem['memory'], $mem['type']);

        $this->debug_html .= "</div>\n\n";

        $this->updateDebugRuntime();

        return true;
    }

//== Render ====================================================================

    // -------------------------------------------------------------------------
    /**
    * Запоминает время начала отрисовки страницы
    * Вставляется непосредственно перед началом рендеринга
    * @param string $template_name  Имя шаблона
    */
    public function beginRender($template_name='') {

        $this->startDebugRuntime();

        // Выводим в Админке предупреждение о включённой отладке
        if (cmsCore::getInstance()->uri_controller == 'admin' && cmsDebugConfig::getInstance()->get('debug_on')) {
            cmsUser::addSessionMessage(LANG_CP_DEBUG_ON_WARNING, 'error');
        }

        // Сохраняем runtime
        $this->render_time_start = microtime(true);
        $this->render_memory_start = memory_get_usage($this->config->memory_real_usage);
        $this->render_memory_peak = memory_get_peak_usage($this->config->memory_real_usage);
        $this->render_sql_time  = $this->data['sql_time_connect'] + $this->data['sql_time_query'];
        $this->render_sql_count = $this->data['sql_count_connect'] + $this->data['sql_count_query'];
        $this->render_include_time = $this->data['auto_time'] + $this->data['include_time'];
        $this->render_include_count = $this->data['auto_count'] + $this->data['include_count'];
        $this->render_hook_time = $this->data['hook_time'];
        $this->render_hook_count = $this->data['hook_count'];
        $this->render_hook_events = $this->data['hook_events'];
        $this->data['render_count']++;

        // Выход, если отладка рендеринга запрещена
        if (!$this->config->debug_on_rendering) {
            $this->updateDebugRuntime();
            return true;
        }

        // Трассировка вызовов. Задаём пропуск вызовов из debug.php
        $trace = $this->getTrace(2, 1);

        // Добавляем строку лога
        $this->debug_html .= '<div class="debug_row">'.
            '<span class="render">Rendering '.$this->data['render_count'].'&nbsp;&nbsp;'.
            '\'<strong><tt>'.$template_name.'</tt></strong>\'&nbsp;&nbsp;start</span> - '.
            $this->getHtmlLogScriptTime($this->debug_time_start).
            ' <tt>&nbsp;&nbsp; '.$trace['point'].'</tt>';

        $this->debug_html .= "</div>\n\n";

        $this->updateDebugRuntime();

        return true;
    }

    // -------------------------------------------------------------------------
    /**
    * Подсчитывает и сохраняет время отрисовки страницы
    * Вставляется непосредственно после ренедеринга страницы
    * @param string $template_name  Имя шаблона
    */
    public function endRender($template_name='') {

        $this->startDebugRuntime();

        // Считаем использованную память
        $mem = $this->calcMemory($this->render_memory_start, $this->render_memory_peak);

        // Сохраняем runtime
        $rt = $this->roundTime($this->debug_time_start - $this->render_time_start);
        $this->data['render_time'] += $rt;
        $this->data['render_memory'] += $this->roundMemory($mem['memory']);
        $this->data['render_memory_type'] = $mem['type'];

        // Обнуляем время - признак того, что рендеринг уже не обсчитывается
        $this->render_time_start = 0;

        // Выход, если отладка рендеринга запрещена
        if (!$this->config->debug_on_rendering) {
            $this->updateDebugRuntime();
            return true;
        }

        // Количество и время SQL
        $sql_time  = $this->data['sql_time_connect'] + $this->data['sql_time_query'] - $this->render_sql_time;
        $sql_count = $this->data['sql_count_connect'] + $this->data['sql_count_query'] - $this->render_sql_count;

        // Количество и время автозагрузок и инклудов
        $include_count = $this->data['auto_count'] + $this->data['include_count'] - $this->render_include_count;
        $include_time  = $this->data['auto_time'] + $this->data['include_time'] - $this->render_include_time;

        // Количество и время хуков и событий
        $hook_count  = $this->data['hook_count'] - $this->render_hook_count;
        $hook_time   = $this->data['hook_time'] - $this->render_hook_time;
        $hook_events = $this->data['hook_events'] - $this->render_hook_events;

        // Добавляем строку лога
        $this->debug_html .= '<div class="debug_row">'.
            '<span class="render">Rendering '.$this->data['render_count'].'&nbsp;&nbsp;'.
            '\'<strong><tt>'.$template_name.'</tt></strong>\'&nbsp;&nbsp;end</span> - '.
            '<strong>'.$rt.'</strong> ms - '.
            $this->getHtmlLogScriptTime($this->debug_time_start).
            $this->getHtmlLogSql($sql_count, $sql_time).
            $this->getHtmlLogInclude($include_count, $include_time).
            $this->getHtmlLogEventHook($hook_events, $hook_count, $hook_time).
            $this->getHtmlLogMemory($mem['memory'], $mem['type']);

        $this->debug_html .= "</div>\n\n";

        $this->updateDebugRuntime();

        return true;
    }


//== Cache =====================================================================

    // -------------------------------------------------------------------------
    /**
    * Запоминает время начала работы с кэшем
    *  Вставляется перед началом работы кэша
    */
    public function beginCache() {
        $this->cache_time_start = microtime(true);
        return true;
    }

    // -------------------------------------------------------------------------
    /**
    * Подсчитывает и сохраняет замеры runtime кэша
    * Вставляется по окончании работы кэша
    * @param string $type   Тип запроса к кэшу (set, get)
    * @param string $key    Ключ элемента кэша
    * @param int    $result Результат обращения - размер элемента
    *                       (для set - в байтах, для get - количество элементов массива)
    * @param mixed  $data   Данные кэша
    */
    public function endCache($type='', $key='', $result='', $data='') {

        $this->startDebugRuntime();

        $rt = $this->debug_time_start - $this->cache_time_start;
        $type = strtolower($type);

        // Обрабатываем запросы SET
        if ($type == 'set') {

            $this->cache_time_set += $rt;
            $this->data['cache_time_set'] = $this->roundTime($this->cache_time_set);
            $this->data['cache_count_set']++;
            // Результат: Ошибка или количество элементов
            $result_text = ($result === false ? 'Error' : count($data, COUNT_RECURSIVE).' items');

        }

        // Обрабатываем запросы GET
        if ($type == 'get') {

            $this->cache_time_get += $rt;
            $this->data['cache_time_get'] = $this->roundTime($this->cache_time_get);
            $this->data['cache_count_get']++;

            // Проверяем успешность получения данных
            if ($result) {
                // Если успешно, то считаем элементы или длину
                $result_text = ($data === false ? 'FALSE' : count($data, COUNT_RECURSIVE).' items');
            } else {
                // Если ошибка, то будем выводить описание из $data и очищаем данные
                $result_text = $data;
                $data = false;
            }
        }

        // Сохраняем runtime
        $this->data['cache_time'] = $this->data['cache_time_set'] + $this->data['cache_time_get'];

        // Выход, если отладка кэша запрещена
        if (!$this->config->debug_on_cache) {
            $this->updateDebugRuntime(true);
            return true;
        }

        // Выход, если не удовлетворяет фильтру по типу
        if ($this->config->filter_cache_type <> 'none') {

            if ($type != $this->config->filter_cache_type) {
                $this->updateDebugRuntime();
                return true;
            }
        }

        // Выход, если не удовлетворяет фильтру по ключу
        if ($this->config->filter_cache_key <> '') {

            if (mb_stripos($key, $this->config->filter_cache_key) === false) {
                $this->updateDebugRuntime(true);
                return true;
            } else {
                $key = $this->highliteStr($this->config->filter_cache_key, $key);
            }
        }

        // Трассировка вызовов. Задаём пропуск вызовов из cache.php
        $trace = $this->getTrace($this->config->trace_level_cache+1, 1);

        // Выход, если не удовлетворяет фильтру по пути/имени подключающего файла
        if ($this->config->filter_cache_from <> '') {

            $filter = $this->filterFrom($this->config->filter_cache_from, $trace);

            if ($filter['result']) {
                $trace = $filter['trace'];
            } else {
                $this->updateDebugRuntime(true);
                return true;
            }
        }

        // Считаем отфильтрованные строки
        $this->data['cache_filter_count_'.$type]++;

        // Добавляем строку лога
        $this->debug_html .= '<div class="debug_row">'.
            '<span class="cache_'.$type.'">Cache <strong>'.strtoupper($type).'</strong> '.$this->data['cache_count_'.$type].'</span> - '.
            '<strong>'.$this->roundTime($rt).'</strong> ms - '.
            $this->getHtmlLogScriptTime($this->debug_time_start).
            ' <tt>&nbsp;&nbsp; '.$trace['point'].'&nbsp;&nbsp;</tt> '.
            'Result: <span class="'.($result === false ? 'error' : 'ok').'">'.$result_text.'</span><br/>'.
            '<pre class="params">'.$key.'</pre>'.
            $trace['html'];

        if ($this->config->cache_log_data) {
            $this->debug_html .= ($data !== false ? '<br/>Data:<br/>'.self::var_dump_color($data) : '');
        }

        $this->debug_html .= "</div>\n\n";

        $this->updateDebugRuntime(true);

        return true;
    }


//== CheckPoints ===============================================================

    // -------------------------------------------------------------------------
    /**
    * Подсчитывает и сохраняет runtime с момента предыдущей точки или со старта скрипта, если это первая точка
    * Вставляется в нужное место кода строкой вида:
    * if (DEBUG_ON) { cmsDebug::getInstance()->checkPoint('NAME','param='.$param, 5, true, true); }
    * Все параметры необязательные
    * @param string $name Название точки, выводится в лог в кавычках после "CheckPoint"
    * @param mixed $params Переменная параметра для вывода в лог
    * @param int $trace_level Глубина трассировки вызовов, 0 - выключить, '' - по умолчанию из конфига
    * @param bool $sql_debug Временно включить показ SQL с этой контрольной точки
    * @param bool $include_debug Временно включить показ инклудов с этой контрольной точки
    */
    public function checkPoint($name='', $params='', $trace_level='', $sql_debug = false, $include_debug = false) {

        $this->startDebugRuntime();

        $this->data['point_count']++;

        // Выход, если показ контрольных точек запрещён
        if (!$this->config->debug_on_point) {
            $this->updateDebugRuntime(true);
            return true;
        }

        // Память и время точки
        $mem_cur = $this->roundMemory(memory_get_usage($this->config->memory_real_usage));
        $mem_peak = $this->roundMemory(memory_get_peak_usage($this->config->memory_real_usage));
        $rt = $this->debug_time_start - $this->point_time_last;
        $this->point_time_last = $this->debug_time_start;
        $mem_delta = round(($mem_cur - $this->point_memory_last) * 1024, 0);
        $this->point_memory_last = $mem_cur;

        // Количество и время SQL
        $sql_count = $this->data['sql_count_connect'] + $this->data['sql_count_query'] - $this->point_sql_count_last;
        $sql_time = 0;

        if ($sql_count > 0) {
            $this->point_sql_count_last = $this->data['sql_count_connect'] + $this->data['sql_count_query'];
            $sql_time = $this->roundTime($this->sql_time_connect + $this->sql_time_query - $this->point_sql_time_last);
            $this->point_sql_time_last = $this->sql_time_connect + $this->sql_time_query;
        }

        // Количество и время автозагрузок и инклудов
        $include_count = $this->data['auto_count'] + $this->data['include_count'] - $this->point_include_count_last;
        $include_time = 0;

        if ($include_count > 0) {
            $this->point_include_count_last = $this->data['auto_count'] + $this->data['include_count'];
            $include_time = $this->roundTime($this->auto_time + $this->include_time - $this->point_include_time_last);
            $this->point_include_time_last = $this->auto_time + $this->include_time;
        }

        // Количество событий
        $hook_events = $this->data['hook_events'] - $this->point_hook_events_last;

        if ($hook_events > 0) {
            $this->point_hook_events_last = $this->data['hook_events'];
        }

        // Количество и время хуков
        $hook_count = $this->data['hook_count'] - $this->point_hook_count_last;
        $hook_time = 0;

        if ($hook_count > 0) {
            $this->point_hook_count_last = $this->data['hook_count'];
            $hook_time = $this->roundTime($this->hook_time - $this->point_hook_time_last);
            $this->point_hook_time_last = $this->hook_time;
        }

        // Трассировка вызовов
        if ($trace_level == '') { $trace_level = $this->config->trace_level_point; }
        $trace = $this->getTrace($trace_level+1, 1);

        // Добавляем строку лога
        $this->debug_html .= '<div class="debug_row">'.
            '<span class="point">Point '.$this->data['point_count'].($name ? '&nbsp;&nbsp;\'<strong><tt>'.$name.'</tt></strong>\'' : '').'</span> - '.
            '<strong>'.$this->roundTime($rt).'</strong> ms - '.
            $this->getHtmlLogScriptTime($this->debug_time_start).
            $this->getHtmlLogSql($sql_count, $sql_time).
            $this->getHtmlLogInclude($include_count, $include_time).
            $this->getHtmlLogEventHook($hook_events, $hook_count, $hook_time).
            $this->getHtmlLogMemoryCP($mem_delta, $mem_cur, $mem_peak).
            ' <tt>&nbsp;&nbsp; '.$trace['point'].'</tt>'.
            ($params !== '' ? '<br/>'.self::var_dump_color($params) : '').
            $trace['html']."</div>\n\n";

        $this->point_debug_on_sql = $sql_debug; // Сохраняем признак временной отладки SQL
        $this->point_debug_on_include = $include_debug; // Сохраняем признак временной отладки инклудов

        $this->updateDebugRuntime(true);

        return true;
    }

//== Errors ====================================================================

    /**
    * Обработчик некритических ошибок PHP
    * Перехватывает ошибки PHP-скриптов и сохраняет их для вывода в лог или в файл.
    */
    public function catchError($errno, $errstr, $errfile, $errline, $errcontext) {

        $this->startDebugRuntime();
        $dt=date("Y.m.d H:i:s");

        // Убираем из пути скрипта домашнюю папку сервера
        $errfile = str_replace($_SERVER['DOCUMENT_ROOT'], '', str_replace("\\", "/", $errfile));

        // Получаем тип ошибки
        $errtype = $this->getErrorType($errno);

        // Получаем признак фатальной ошибки
        $critical = ($errno & (E_ERROR | E_PARSE | E_COMPILE_ERROR | E_CORE_ERROR));

        // Трассировка вызовов только для нефатальных ошибок
        // Так как при фатальных ошибках debug_backtrace() ничего полезного не возвращает
        $trace_html = '';
        if (!$critical) {
            $trace = $this->getTrace($this->config->trace_level_error, 0);
            $trace_html = $trace['html'];
        }

        // Сохраняем описание ошибки для лога
        $this->errors_html .= '<div class="debug_error">'.
            '<span class="err">'.($critical ? '<strong><span class="error">Fatal error '.$errtype.'</span></strong>: '.$errstr : '<span class="warning">'.$errtype.'</span>: '.$errstr).'</span>'.
            ' <tt>&nbsp;&nbsp;'.($critical ? '<strong>' : '').'<span class="file">'.$errfile.' ('.$errline.')</span>'.($critical ? '<strong>' : '').'</tt>';

        if ($this->config->error_log_data) {
            $this->errors_html .= ($errcontext ? '<br/>'.self::var_dump_color($errcontext) : '');
        }

        $this->errors_html .= $trace_html."</div>\n\n";

        // Пробуем определить пользователя, под которым произошла ошибка
        $user_str = 'unknown';
        if (class_exists('cmsUser', false)) {
            $user = cmsUser::getInstance();
            $user_str = ($user->id > 0 ? $user->id.'&ensp;\''.$user->nickname.'\'&ensp;('.$user->email.')' : 'guest');
        }

        // Получаем адрес страницы с ошибкой
        $page_url = cmsConfig::getInstance()->host.href_to_current();

        // Подготовка письма админу о критической ошибке
        if ($critical && ($this->config->error_critical_mail ||
                          $this->config->error_critical_msg  ||
                          $this->config->error_critical_notice)) {

                $letter = '<strong>Fatal error</strong> '.$errtype.': '.$errstr."<br/>\r\n".
                        'in <strong>'.$errfile.'</strong> at line <strong>'.$errline."</strong><br/>\r\n".
                        'user:&ensp;'.$user_str."<br/>\r\n".
                        'url: <a href="'.$page_url.'">'.$page_url.'</a>';
        }

        // Отправка email админу о критической ошибке
        if ($critical && $this->config->error_critical_mail && $this->config->error_critical_mail_to) {
            $messenger = cmsCore::getController('messages');
            $user_to = cmsCore::getModel('users')->getUser($this->config->error_critical_user);
            $to = array('email' => $this->config->error_critical_mail_to, 'name' => '');
            $messenger->sendEmail($to, array('text' => $letter));
        }

        // Отправка уведомления админу о критической ошибке
        if ($critical && $this->config->error_critical_notice) {
            $messenger = cmsCore::getController('messages');
            $messenger->addRecipient($this->config->error_critical_user);
            $messenger->sendNoticePM(array(
                'content' => $letter
            ));
        }

        // Отправка личного сообщения админу о критической ошибке
        if ($critical && $this->config->error_critical_msg) {
            $messenger = cmsCore::getController('messages');
            $messenger->clearRecipients();
            $messenger->setSender($this->config->error_critical_user);
            $messenger->addRecipient($this->config->error_critical_user);
            $messenger->sendMessage($letter);
        }

        $this->updateDebugRuntime(true);

        return true;
    }

    /**
    * Обработчик фатальных ошибок PHP
    * Перехватывает критические неисправимые ошибки PHP-скриптов и
    * передаёт их в catchError() для вывода в лог на экран и в файл.
    * Потом выводит сообщение об ошибке, а также всю накопленную к этому моменту
    * информацию (готовая часть страницы и отладка) и останавливает работу скриптов.
    */
    public function catchFatal() {

        $errno = 0;

        if (@is_array($e = @error_get_last())) {
            $errno = isset($e['type']) ? $e['type'] : 0;
            $errstr = isset($e['message']) ? $e['message'] : '';
            $errfile = isset($e['file']) ? $e['file'] : '';
            $errline = isset($e['line']) ? $e['line'] : '';
        }

        if ($errno > 0) {

            $this->catchError($errno, $errstr, $errfile, $errline, '');
            if ($this->isAllowShow()) {

                // Если разрешено (то есть, страницу смотрит админ),
                // выводим страницу (всё, что есть к этому моменту) и отладочную инфу
                $this->calcDebug;
                echo $this->getHtmlFull();
                ob_end_flush();

            } else {

                // Если запрещено, то выводим сообщение для пользователей
                ob_clean;

                // Заполняем заголовки об ошибке сервера
                header($_SERVER['SERVER_PROTOCOL'].' 500 Internal Server Error', true, 500);
                header('Status: 500 Internal Server Error', true, 500);

                if ($this->config->error_critical_page) {
                    // Выводим сообщение из конфига отладки пользователю на чистой странице
                    echo $this->config->error_critical_page;
                } else {
                    // Или показываем простое сообщение
                    echo '500 Internal Server Error';
                }

            }

            exit;
        }

    }


//== Trace =====================================================================

    // -------------------------------------------------------------------------
    /**
    * Обратная трассировка вызовов функций
    * @param int $trace_level  Глубина трассировки
    * @param int $shift        Пропуск последних уровней
    * @return array
    *    'point' Строка с местом нахождения сработавшей точки отладки CheckPoint
    *    'html'  Строка html со списком вызывавших функций
    */
    private function getTrace($trace_level=10, $shift=0) {

        $html = '';
        $point = '';

        $bt=debug_backtrace();
        $lvl = -1;
        $sp = 1; // Начальный сдвиг трассировки вправо

        foreach ($bt as $k=>$v) {

            $lvl++;
            if ($lvl<=$shift) { continue; }
            if ($lvl>$trace_level+1) { break; }
            extract($v);

            if (!isset($file)) { $file = ''; }
            if (!isset($line)) { $line = ''; }

            if ($file == '' && $line == '' && $function == 'spl_autoload_call') {
                $shift++; // Сдвиг на следующий уровень для пропуска spl_autoload_call без файла
                continue;
            }

            /*
            // Сдвиг на следующий уровень для пропуска cmsDatabase
            if ($shift && strstr($file, 'database.php')) {
                $shift++;
                continue;
            }
            */

            $file = str_replace($_SERVER['DOCUMENT_ROOT'], '', str_replace("\\", "/", $file));

            if ($lvl==1+$shift) {  // Сработавшая точка отладки
                if ($function == 'dcp') { $function = ''; }
                $point = $file.' ('.$line.') ';
                if ($function) { $point .= (isset($class) ? $class.$type : '').$function; }
            } else {  // Остальные вызвавшие функции
                $html .= '<br/>'.str_repeat('&nbsp;&nbsp;', $sp++);
                $html .= $file.' ('.$line.') '.(isset($class) ? $class.$type : '').$function;
            }
        }

        $ret['point'] = '<span class="file">'.$point.'</span>';
        $ret['html'] = '<span class="trace">'.$html.'</span>';

        return $ret;
    }

//== Вычисления ================================================================

    // -------------------------------------------------------------------------
    /**
    * Вычисляет оставшиеся значения runTime
    */
    public function calcDebug() {

        $now = microtime(true);

        // Считаем память скрипта
        $this->data['memory_end']  = $this->roundMemory(memory_get_usage($this->config->memory_real_usage));
        $this->data['memory_peak'] = $this->roundMemory(memory_get_peak_usage($this->config->memory_real_usage));
        $this->data['debug_memory']  = $this->roundMemory($this->debug_memory);
        $this->data['memory_script_peak'] = $this->data['memory_peak'] - $this->data['debug_memory'];

        // Если возможно, считаем время загрузки PHP-модуля до старта скрипта
        if (isset($_SERVER['REQUEST_TIME_FLOAT'])) {
          $this->data['start_time'] = $this->roundTime($this->time_start - $_SERVER['REQUEST_TIME_FLOAT']);
        }

        // Считаем время
        $this->data['full_time']   = $this->roundTime($now - $this->time_start) + $this->data['start_time'];
        if ($this->config->emulate_lag > 0) { $this->data['full_time'] -= $this->config->emulate_lag; }
        $this->data['debug_time']  = $this->roundTime($this->debug_time);
        $this->data['script_time'] = $this->data['full_time'] - $this->data['start_time'] - $this->data['debug_time'];
        $this->data['php_time']    = $this->data['script_time'] - $this->data['sql_time'] - $this->data['cache_time'];

    }

    // -------------------------------------------------------------------------
    /**
    * Возвращает объём использованной участком кода памяти
    * @param int $start_memory  Память на начало работы участка кода
    * @param int $start_peak    Пик памяти на начало работы участка кода
    * @return array
    *    'memory' int     Память
    *    'type'   string  Тип расчёта ('peak' - по пику, 'end' - по окончанию)
    */
    private function calcMemory($start_memory, $start_peak) {

        $mem_peak = memory_get_peak_usage($this->config->memory_real_usage);

        if ($mem_peak > $start_peak) {
            // Если пик памяти был повышен за время работы участка кода,
            // то потребление памяти точно равно разнице между этим пиком и стартом
            $mem_delta = $mem_peak - $start_memory;
            $mem_type = 'peak';
        } else {
            // Если пик памяти не повышался, то использование памяти
            // считается как разница между выходным и входным объёмами
            $mem_delta = memory_get_usage($this->config->memory_real_usage) - $start_memory;
            $mem_type = 'end';
        }

        return array('memory' => $mem_delta, 'type' => $mem_type);
    }


//== Html-блоки для вывода =====================================================

    // -------------------------------------------------------------------------
    /**
    * Возвращает html-строку с итоговой таблицей и подробной информацией по отладке
    * @return string
    */
    public function getHtmlFull() {

        return '<div id="debug"><div class="wrapper">'.
            $this->errors_html.
            $this->getHtmlTable().
            $this->getHtmlFilters().
            $this->getHtmlIncludes().
            $this->getHtmlHooks().
            $this->getHtmlWidgets().
            $this->debug_html.
            '</div></div>';
    }

    // -------------------------------------------------------------------------
    /**
    * Возвращает готовую html-таблицу с итоговыми результатами замеров времени выполнения
    * @return string
    */
    private function getHtmlTable() {

        // Вычисляем значения runTime
        $this->calcDebug();

        $config = cmsConfig::getInstance();

        // ===== Table header =====

        $html = '<table><thead><tr>'.
            '<td><u>Script</u></td>'.
            '<td><u>PHP</u></td>'.
            '<td><u>SQL</u></td>'.
            '<td><u>Cache</u> - '.($config->cache_enabled ? '<span class="cache_set">on \''.$config->cache_method.'\'</span>' : 'off').'</td>'.
            '<td><u>Memory</u>'.($this->config->memory_real_usage ? ' (real)' : ' (exact)').'</td>'.
            '</tr></thead>'.
            '<tbody><tr valign="top">';

        // == Script ===========================================================

        $html .= '<td>';

        // Script time
        $html .= '<div class="script">'.
            'script time:&ensp;<font size="+1"><span class="help" title="Script runtime = full time - debug time"><strong>'.$this->data['script_time'].'</strong></span></font> ms'.
            '</div>';

        // PHP start time
        $html .= '<div class="debug_info">'.
            'php start time:&ensp;<span class="help" title="The time from receiving an http-request to the starting script"><strong>'.$this->data['start_time'].'</strong></span> ms'.
            '</div>';

        // Debug time
        $html .= '<div class="debug_info">'.
            'debug time:&ensp;<span class="help" title="Debug runtime"><strong>'.$this->data['debug_time'].'</strong></span> ms '.
            '<span class="help" title="Percentage of the full time">('.$this->percent($this->data['full_time'], $this->data['debug_time']).'%)</span>'.
            '</div>';

        // Full time
        $html .= '<div class="debug_info">'.
            'full time:&ensp;<span class="help" title="Full runtime = start time + total time of all scripts + debug time"><strong>'.$this->data['full_time'].'</strong></span> ms'.
            '</div>';

        // Emulate lag
        if ($this->config->emulate_lag>0) {
            $html .= '<br/><div class="warning">'.
                'emulate lag:&ensp;<strong>'.$this->config->emulate_lag.'</strong> ms'.
                '</div>';
        }

        // Points count
        $html .= ($this->data['point_count'] > 0 ?
            '<br/><div class="point"><span class="'.($this->config->debug_on_point ? 'debug_on' : '').'">check points</span>:&ensp;<strong>'.$this->data['point_count'].'</strong></div>' :
            '');

        $html .= '</td><td>';

        // == PHP ==============================================================

        // Time
        $html .= '<div class="php">'.
            'php time:&ensp;<strong>'.$this->data['php_time'].' </strong> ms '.
            '<span class="help" title="Percentage of the script time">('.$this->percent($this->data['script_time'], $this->data['php_time']).'%)</span>'.
            '</div>';

        // Autoloads
        $html .= '<div class="auto info_block">'.
            '<span class="'.($this->config->debug_on_auto ? 'debug_on' : '').'">autoloads</span>:<br/>'.
            '- count:&ensp;<strong>'.$this->data['auto_count'].'</strong><br/>'.
            '- time:&ensp;<strong>'.$this->data['auto_time'].'</strong> ms '.
            '<span class="help" title="Percentage of the php time">('.$this->percent($this->data['php_time'], $this->data['auto_time']).'%)</span>'.
            '</div>';

        // Includes
        $html .= '<div class="include info_block">'.
            '<span class="'.($this->config->debug_on_include ? 'debug_on' : '').'">includes</span>:<br/>'.
            '- count:&ensp;<strong>'.$this->data['include_count'].'</strong><br/>'.
            '- time:&ensp;<strong>'.$this->data['include_time'].'</strong> ms '.
            '<span class="help" title="Percentage of the php time">('.$this->percent($this->data['php_time'], $this->data['include_time']).'%)</span>'.
            '</div>';

        $html .= '</td><td>';

        // == SQL ==============================================================

        // Time
        $html .= '<div class="sql">'.
            "sql time:&ensp;<strong>".$this->data['sql_time'].'</strong> ms '.
            '<span class="help" title="Percentage of the script time">('.$this->percent($this->data['script_time'], $this->data['sql_time']).'%)</span>'.
            '</div>';

        // Connects
        $html .= '<div class="connect info_block">'.
            '<span class="'.($this->config->debug_on_sql ? "debug_on" : '').'">connects</span>:<br/>'.
            '- count:&ensp;<strong>'.$this->data['sql_count_connect'].'</strong><br/>'.
            '- time:&ensp;<strong>'.$this->data['sql_time_connect'].'</strong> ms '.
            '<span class="help" title="Percentage of the sql time">('.$this->percent($this->data['sql_time'], $this->data['sql_time_connect']).'%)</span>'.
            '</div>';

        // Queries
        $html .= '<div class="query info_block">'.
            '<span class="'.($this->config->debug_on_sql ? "debug_on" : '').'">queries</span>:<br/>'.
            '- count:&ensp;<strong>'.$this->data['sql_count_query'].'</strong><br/>'.
            '- time:&ensp;<strong>'.$this->data['sql_time_query'].'</strong> ms '.
            '<span class="help" title="Percentage of the sql time">('.$this->percent($this->data['sql_time'], $this->data['sql_time_query']).'%)</span><br/>'.
            ($this->data['sql_errors'] ? '<span class="error">- errors:&ensp;<strong>'.$this->data['sql_errors'].'</strong></span>' : '').
            ($this->data['sql_warnings'] ? '<span class="warning">- warnings:&ensp;<strong>'.$this->data['sql_warnings'].'</strong></span>' : '').
            '</div>';

        $html .= '</td>';

        // == Cache ============================================================

        // Time
        $html .= '<td><div class="cache">'.
            'cache time:&ensp;<strong>'.$this->data['cache_time'].'</strong> ms '.
            '<span class="help" title="Percentage of the script time">('.$this->percent($this->data['script_time'], $this->data['cache_time']).'%)</span>'.
            '</div>';

        // SET
        $html .= '<div class="cache_set info_block">'.
            '<span class="'.($this->config->debug_on_cache ? 'debug_on' : '').'">set</span>:<br/>'.
            '- count:&ensp;<strong>'.$this->data['cache_count_set'].'</strong><br/>'.
            '- time:&ensp;<strong>'.$this->data['cache_time_set'].'</strong> ms '.
            '<span class="help" title="Percentage of the cache time">('.$this->percent($this->data['cache_time'], $this->data['cache_time_set']).'%)</span>'.
            '</div>';

        // GET
        $html .= '<div class="cache_get info_block">'.
            '<span class="'.($this->config->debug_on_cache ? 'debug_on' : '').'">get</span>:<br/>'.
            '- count:&ensp;<strong>'.$this->data['cache_count_get'].'</strong><br/>'.
            '- time:&ensp;<strong>'.$this->data['cache_time_get'].'</strong> ms '.
            '<span class="help" title="Percentage of the cache time">('.$this->percent($this->data['cache_time'], $this->data['cache_time_get']).'%)</span>'.
            '</div>';

        $html .= '</td>';

        // == Memory ===========================================================

        // Peak
        $html .= '<td><div class="memory">'.
            'script peak:&ensp;<span class="help" title="Maximum of the memory usage (script only w/o debug)"><strong>'.$this->data['memory_script_peak'].'</strong></span> MB'.
            '</div>';

        // Full memory
        $html .= '<div class="memory_use info_block">'.
            'start:&ensp;<span class="help" title="Memory at the script start">'.$this->data['memory_start'].'</span> MB<br/>'.
            'end:&ensp;<span class="help" title="Memory at the script end (script and debug)">'.$this->data['memory_end'].'</span> MB<br/>'.
            'full peak:&ensp;<span class="help" title="Peak of the script memory (script and debug)">'.$this->data['memory_peak'].'</span> MB'.
            '</div>';

        // Debug
        $html .= '<br /><div class="debug_info">'.
            'debug:&ensp;<span class="help" title="Memory of the debugging (exact)">'.$this->data['debug_memory'].'</span> MB'.
            '</div>';

        $html .= '</td></tr>';

        // == Разные части скрипта =============================================

        $html .= '<tr><td><u>Parts of script</u></td></tr><tr valign="top">';
        $html .= '<td>';

        // --- Hooks ---
        $html .= '<div class="hook info_block">'.
            '<span class="event'.($this->config->debug_on_hook ? ' debug_on' : '').'">Events</span>/<span class="'.($this->config->debug_on_hook ? 'debug_on' : '').'">Hooks</span>:<br/>'.
            '- count:&ensp;<span class="event help" title="Events count"><strong>'.$this->data['hook_events'].'</strong></span> / <span class="help" title="Hooks count"><strong>'.$this->data['hook_count'].'</strong></span><br/>'.
            '- time:&ensp;<strong>'.$this->data['hook_time'].'</strong> ms '.
            '<span class="help" title="Percentage of the script time">('.$this->percent($this->data['script_time'], $this->data['hook_time']).'%)</span><br/>'.
            '- memory:&ensp;<strong>'.$this->data['hook_memory'].'</strong> MB'.
            '</div>';

        $html .= '</td><td>';

        // --- Widgets ---
        $html .= '<div class="widget info_block">'.
            '<span class="'.($this->config->debug_on_widget ? 'debug_on' : '').'">Widgets</span>:<br/>'.
            '- count:&ensp;<strong>'.$this->data['widget_count'].'</strong><br />'.
            '- time:&ensp;<strong>'.$this->data['widget_time'].'</strong> ms '.
            '<span class="help" title="Percentage of the script time">('.$this->percent($this->data['script_time'], $this->data['widget_time']).'%)</span><br/>'.
            '- memory:&ensp;<strong>'.$this->data['widget_memory'].'</strong> MB'.
            '</div>';

        $html .= '</td><td>';

        // --- Controller ---
        $html .= '<div class="control info_block">'.
            '<span class="'.($this->config->debug_on_controller ? 'debug_on' : '').'">Controller</span>:<br />'.
            '- count:&ensp;<strong>'.$this->data['control_count'].'</strong><br />'.
            '- time:&ensp;<strong>'.$this->data['control_time'].'</strong> ms '.
            '<span class="help" title="Percentage of the script time">('.$this->percent($this->data['script_time'], $this->data['control_time']).'%)</span><br />'.
            '- memory:&ensp;<strong>'.$this->data['control_memory'].'</strong> MB ('.$this->data['control_memory_type'].')'.
            '</div>';

        $html .= '</td><td>';

        // --- Template init ---
        $html .= '<div class="template">'.
            '<span class="'.($this->config->debug_on_template ? 'debug_on' : '').'">Template init</span>:<br />'.
            '- count:&ensp;<strong>'.$this->data['template_count'].'</strong><br />'.
            '- time:&ensp;<strong>'.$this->data['template_time'].'</strong> ms '.
            '<span class="help" title="Percentage of the script time">('.$this->percent($this->data['script_time'], $this->data['template_time']).'%)</span><br />'.
            '- memory:&ensp;<strong>'.$this->data['template_memory'].'</strong> MB ('.$this->data['template_memory_type'].')'.
            '</div>';

        $html .= '</td><td>';

        // --- Template rendering ---
        $html .= '<div class="render">'.
            '<span class="'.($this->config->debug_on_rendering ? 'debug_on' : '').'">Template rendering</span>:<br />'.
            '- count:&ensp;<strong>'.$this->data['render_count'].'</strong><br />'.
            '- time:&ensp;<strong>'.$this->data['render_time'].'</strong> ms '.
            '<span class="help" title="Percentage of the script time">('.$this->percent($this->data['script_time'], $this->data['render_time']).'%)</span><br />'.
            '- memory:&ensp;<strong>'.$this->data['render_memory'].'</strong> MB ('.$this->data['render_memory_type'].')'.
            '</div>';

        $html .= '</td>';

        $html .= "</tr></tbody></table>\n\n";

        return $html;
    }

    // -------------------------------------------------------------------------
    /**
    * Возвращает html-блок с описанием включённых фильтров
    * @return string
    */
    private function getHtmlFilters() {

        $html = '';

        // Фильтр по строке SQL по части строки запроса
        if ($this->sql_filter_on && $this->config->filter_query_sql <> '') {
            $html .= $this->getHtmlFiltersRow('query', 'SQL', 'sql string', $this->config->filter_query_sql, $this->data['sql_filter_count']);
        }

        // Фильтр по строке SQL по запрашивающему файлу
        if ($this->sql_filter_on && $this->config->filter_query_from <> '') {
            $html .= $this->getHtmlFiltersRow('query', 'SQL', 'from', $this->config->filter_query_from, $this->data['sql_filter_count']);
        }

        // Фильтр автозагрузок по подключаемому файлу
        if ($this->auto_filter_on && $this->config->filter_auto_file <> '') {
            $html .= $this->getHtmlFiltersRow('auto', 'Autoload', 'file', $this->config->filter_auto_file, $this->data['auto_filter_count']);
        }

        // Фильтр автозагрузок по подключающему файлу
        if ($this->auto_filter_on && $this->config->filter_auto_from <> '') {
            $html .= $this->getHtmlFiltersRow('auto', 'Autoload', 'from', $this->config->filter_auto_from, $this->data['auto_filter_count']);
        }

        // Фильтр инклудов по подключаемому файлу
        if ($this->include_filter_on && $this->config->filter_include_file <> '') {
            $html .= $this->getHtmlFiltersRow('include', 'Include', 'file', $this->config->filter_include_file, $this->data['include_filter_count']);
        }

        // Фильтр инклудов по подключающему файлу
        if ($this->include_filter_on && $this->config->filter_include_from <> '') {
            $html .= $this->getHtmlFiltersRow('include', 'Include', 'from', $this->config->filter_include_from, $this->data['include_filter_count']);
        }

          // Фильтр событий по событию
        if ($this->config->debug_on_hook) {

            $filter_hook_event = (
                    $this->config->filter_hook_event_str <> '' ?
                    $this->config->filter_hook_event_str :
                    ( $this->config->filter_hook_event <> 'none' ? $this->config->filter_hook_event : '' )
            );

            if ($filter_hook_event) {
                $html .= $this->getHtmlFiltersRow('event', 'Event', 'event', $filter_hook_event, $this->data['hook_filter_events']);
            }
        }

        // Фильтр событий по контроллеру
        if ($this->config->debug_on_hook && $this->config->filter_hook_control <> 'none') {
            $html .= $this->getHtmlFiltersRow('event', 'Event', 'controller', $this->config->filter_hook_control, $this->data['hook_filter_events']);
        }

        // Фильтр событий по вызывающему файлу
        if ($this->config->debug_on_hook && $this->config->filter_hook_from <> '') {
            $html .= $this->getHtmlFiltersRow('event', 'Event', 'from', $this->config->filter_hook_from, $this->data['hook_filter_events']);
        }

          // Фильтр хуков по событию
        if ($filter_hook_event) {
            $html .= $this->getHtmlFiltersRow('hook', 'Hook', 'event', $filter_hook_event, $this->data['hook_filter_count']);
        }

        // Фильтр хуков по контроллеру
        if ($this->config->debug_on_hook && $this->config->filter_hook_control <> 'none') {
            $html .= $this->getHtmlFiltersRow('hook', 'Hook', 'controller', $this->config->filter_hook_control, $this->data['hook_filter_count']);
        }

        // Фильтр хуков по вызывающему файлу
        if ($this->config->debug_on_hook && $this->config->filter_hook_from <> '') {
            $html .= $this->getHtmlFiltersRow('hook', 'Hook', 'from', $this->config->filter_hook_from, $this->data['hook_filter_count']);
        }

        // Фильтр виджетов по виджету
        if ($this->config->debug_on_widget && $this->config->filter_widget_widget <> 'none') {
            $html .= $this->getHtmlFiltersRow('widget', 'Widget', 'widget', $this->config->filter_widget_widget, $this->data['widget_filter_count']);
        }

        // Фильтр виджетов по контроллеру
        if ($this->config->debug_on_widget && $this->config->filter_widget_control <> 'none') {
            $html .= $this->getHtmlFiltersRow('widget', 'Widget', 'controller', $this->config->filter_widget_control, $this->data['widget_filter_count']);
        }

        // Фильтр обращений к кэшу по типу
        if ($this->config->debug_on_cache && $this->config->filter_cache_type <> 'none') {
            $html .= $this->getHtmlFiltersRow('cache_'.$this->config->filter_cache_type, 'Cache', 'type', $this->config->filter_cache_type, $this->data['cache_filter_count_set'] + $this->data['cache_filter_count_get']);
        }

        // Фильтр обращений к кэшу по ключу
        if ($this->config->debug_on_cache && $this->config->filter_cache_key <> '') {
            $html .= $this->getHtmlFiltersRow('cache_set', 'Cache SET', 'key', $this->config->filter_cache_key, $this->data['cache_filter_count_set']);
            $html .= $this->getHtmlFiltersRow('cache_get', 'Cache GET', 'key', $this->config->filter_cache_key, $this->data['cache_filter_count_get']);
        }

        // Фильтр обращений к кэшу по вызывающему файлу
        if ($this->config->debug_on_cache && $this->config->filter_cache_from <> '') {
            $html .= $this->getHtmlFiltersRow('cache_set', 'Cache SET', 'from', $this->config->filter_cache_from, $this->data['cache_filter_count_set']);
            $html .= $this->getHtmlFiltersRow('cache_get', 'Cache GET', 'from', $this->config->filter_cache_from, $this->data['cache_filter_count_get']);
        }

        // Шапка
        if ($html <> '') {
            $html = '<table class="filter">'.
            '<thead><tr><td><u>Log</u></td><td colspan="2" class="center"><u>Used filter</u></td><td class="center"><u>Rows</u></td></tr></thead>'.
            '<tbody>'.$html."</tbody></table>\n\n";
        }

        return $html;
    }

    // -------------------------------------------------------------------------
    /**
    * Возвращает html-строку для таблицы фильтров в getHtmlFilters()
    * @param string $class  CSS-класс
    * @param string $log    Лог
    * @param string $filter Фильтр
    * @param string $val    Значение фильтра
    * @param int    $count  Количество строк
    * @return string
    */
    private function getHtmlFiltersRow($class='', $log='', $filter='', $val='', $count=0) {

        $html .= '<tr>'.
            '<td class="'.$class.'">'.$log.'</td>'.
            '<td class="min_pad_right">'.$filter.' =</td>'.
            '<td class="tt min_pad_left">\'<span class="'.$class.'">'.$val.'</span>\'</td>'.
            '<td class="'.$class.' center">'.$this->strongNotNull($count).'</td>'.
            '</tr>';

        return $html;
    }

    // -------------------------------------------------------------------------
    /**
    * Возвращает готовую html-таблицу с количествами и временем инклудов файлов
    * @return string
    */
    private function getHtmlIncludes() {

        if (!$this->config->debug_on_include || count($this->includes) == 0) { return ''; }

        $html = '';
        $lines = 0;

        ksort($this->includes, SORT_STRING);

        foreach ($this->includes as $f => $v) {

            if (!$this->config->includes_table_error || $v['count'] > 1 || $v['error'] > 0) {

                $html .= '<tr><td>'.$f.'</td><td'.($v['count']>1 ? ' class="warning"' : '').' align="center">'.$v['count'].'</td>'.
                    '<td align="center">'.$v['time'].'</td>'.
                    '<td align="center"'.($v['error']>0 ? ' class="error">'.$v['error'] : ($v['count']>1 ? ' class="warning">'.($v['count']-1) : '')).'</td></tr>';

                $lines++;
            }
        }

        $html = '<table><thead><tr>'.
                '<td><u><span class="include">Included files</span></u> ('.$lines.' from '.count($this->includes).')'.
                ( $this->config->filter_include_file.$this->config->filter_include_from <> '' ? ' - filter' : '' ) . '</td>'.
                '<td><u>Count</u></td>'.
                '<td><u>Time sum, ms</u></td>'.
                '<td><u>Errors</u></td>'.
                '</tr></thead><tbody>'.$html;

        $html .= "</tbody></table>\n\n";

        return $html;
    }

    // -------------------------------------------------------------------------
    /**
    * Возвращает готовую html-таблицу с событиями-хуками-контроллерами
    * @return string
    */
    private function getHtmlHooks() {

        if (!$this->config->debug_on_hook || $this->config->hook_table == 'none') { return ''; }

        $html = '';
        $html_thead = '';

        switch ($this->config->hook_table) {

            case 'act_hooks':  // Только активные хуки - по хукам

                $html_thead = '<td><u><span class="event">Hook</span></u></td>'.
                              '<td><u><span class="hook">Controller</span></u></td>'.
                              '<td><u>Count</u></td>'.
                              '<td><u>Time sum, ms</u></td>'.
                              '<td><u>Time avg, ms</u></td>';

                ksort($this->hooks);

                foreach ($this->hooks as $key => $val) {

                    ksort($val);

                    foreach ($val as $k => $v) {

                        $html .= '<tr>'.
                                 '<td>'.$key.'</td>'.
                                 '<td>'.$k.'</td>'.
                                 '<td align="center">'.($v['count']>0 ? $v['count'] : '').'</td>'.
                                 '<td align="center">'.($v['time']>0 ? $v['time'] : '').'</td>'.
                                 '<td align="center">'.($v['count']>0 ? round($v['time']/$v['count'], 1) : '').'</td>'.
                                 '</tr>';
                    }
                }

                break;

            case 'act_controls':  // Только активные хуки - по контроллерам

                $html_thead = '<td><u><span class="hook">Controller</span></u></td>'.
                              '<td><u><span class="event">Hook</span></u></td>'.
                              '<td><u>Count</u></td>'.
                              '<td><u>Time sum, ms</u></td>'.
                              '<td><u>Time avg, ms</u></td>';

                // Перегруппируем таблицу сработавших хуков по контроллерам
                ksort($this->hooks);

                foreach ($this->hooks as $key => $val) {

                    foreach ($val as $k => $v) {
                        $hooks[$k][$key] = $v;
                    }
                }

                foreach ($hooks as $key => $val) {

                    ksort($val);

                    foreach ($val as $k => $v) {

                        $html .= '<tr>'.
                                 '<td>'.$key.'</td>'.
                                 '<td>'.$k.'</td>'.
                                 '<td align="center">'.($v['count']>0 ? $v['count'] : '').'</td>'.
                                 '<td align="center">'.($v['time']>0 ? $v['time'] : '').'</td>'.
                                 '<td align="center">'.($v['count']>0 ? round($v['time']/$v['count'], 1) : '').'</td>'.
                                 '</tr>';
                    }
                }

                break;

            case 'all_hooks':  // Все зарегистрированные хуки - по хукам

                $html_thead = '<td><u><span class="event">Hook</span></u></td>'.
                              '<td><u><span class="hook">Controller</span></u></td>'.
                              '<td><u>Count</u></td>'.
                              '<td><u>Time sum, ms</u></td>'.
                              '<td><u>Time avg, ms</u></td>';

                // Получаем массив зарегестрированных обработчиков (пар хуков-контроллеров)
                $events = cmsEventsManager::getAllListeners();
                ksort($events);

                foreach ($events as $key => $val) {

                    // Пропуск строки, если не удовлетворяет фильтру по событию
                    if ($this->config->filter_hook_event <> 'none') {
                        if ($key != $this->config->filter_hook_event) { continue; }
                    }

                    ksort($val);

                    foreach ($val as $k => $v) {

                        // Пропуск строки, если не удовлетворяет фильтру по контроллеру
                        if ($this->config->filter_hook_control <> 'none') {
                            if ($v != $this->config->filter_hook_control) { continue; }
                        }

                        $html .= '<tr>'.
                                 '<td>'.$key.'</td>'.
                                 '<td>'.$v.'</td>'.
                                 '<td align="center">'.(isset($this->hooks[$key][$v]) ? $this->hooks[$key][$v]['count'] : '').'</td>'.
                                 '<td align="center">'.(isset($this->hooks[$key][$v]) ? $this->hooks[$key][$v]['time'] : '').'</td>'.
                                 '<td align="center">'.(isset($this->hooks[$key][$v]) ? round($this->hooks[$key][$v]['time']/$this->hooks[$key][$v]['count'], 1) : '').'</td>'.
                                 '</tr>';
                    }
                }

                break;

            case 'all_controls':  // Все зарегистрированные хуки - по контроллерам

                $html_thead = '<td><u><span class="hook">Controller</span></u></td>'.
                              '<td><u><span class="event">Hook</span></u></td>'.
                              '<td><u>Count</u></td>'.
                              '<td><u>Time sum, ms</u></td>'.
                              '<td><u>Time avg, ms</u></td>';

                // Получаем массив манифестов контроллеров с хуками
                $manifests = cmsCore::getControllersManifests();
                ksort($manifests);

                foreach ($manifests as $controller => $man) {

                    // Пропуск строки, если не удовлетворяет фильтру по контроллеру
                    if ($this->config->filter_hook_control <> 'none') {
                        if ($controller != $this->config->filter_hook_control) { continue; }
                    }

                    asort($man['hooks']);

                    foreach ($man['hooks'] as $k => $h) {

                        // Пропуск строки, если не удовлетворяет фильтру по событию
                        if ($this->config->filter_hook_event <> 'none') {
                            if ($h != $this->config->filter_hook_event) { continue; }
                        }

                        $html .= '<tr>'.
                                 '<td>'.$controller.'</td>'.
                                 '<td>'.$h.'</td>'.
                                 '<td align="center">'.(isset($this->hooks[$h][$controller]) ? $this->hooks[$h][$controller]['count'] : '').'</td>'.
                                 '<td align="center">'.(isset($this->hooks[$h][$controller]) ? $this->hooks[$h][$controller]['time'] : '').'</td>'.
                                 '<td align="center">'.(isset($this->hooks[$h][$controller]) ? round($this->hooks[$h][$controller]['time']/$this->hooks[$h][$controller]['count'], 1) : '').'</td>'.
                                 '</tr>';
                    }
                }

                break;

            case 'list_events':  // Список произошедших событий

                $html_thead = '<td><u><span class="event">Event</span></u></td><td><u>Count</u></td>';

                ksort($this->events);

                foreach ($this->events as $k => $v) {
                    $html .= '<tr><td>'.$k.'</td><td align="center">'.$this->events[$k].'</td></tr>';
                }

                break;

            case 'list_hooks':  // Список зарегистрированных хуков

                $html_thead = '<td><u><span class="event">Hook</span></u></td>';

                $listeners = cmsEventsManager::getAllListeners();
                ksort($listeners);

                foreach ($listeners as $event => $v) {
                    $html .= '<tr><td>'.$event.'</td></tr>';
                }

                break;

            case 'list_controls':  // Список контроллеров

                $html_thead = '<td><u><span class="hook">Controller</span></u></td>';

                $manifests = cmsCore::getControllersManifests();
                ksort($manifests);

                foreach ($manifests as $controller_name => $v) {
                    $html .= '<tr><td>'.$controller_name.'</td></tr>';
                }

                break;
        }

        $html = '<table><thead><tr>'.$html_thead.'</tr></thead><tbody>'.$html."</tbody></table>\n\n";

        return $html;
    }

    // -------------------------------------------------------------------------
    /**
    * Возвращает готовую html-таблицу с количествами и временем виджетов
    * @return string
    */
    private function getHtmlWidgets() {

        if (!$this->config->debug_on_widget) { return ''; }

        if ($this->config->widget_table_active && count($this->widgets) == 0) { return ''; }

        $html = '';

        if (!$this->config->widget_table_active) {

            // Получаем полную таблицу виджетов
            $widgets_list = cmsCore::getModel('widgets')->getAvailableWidgets();

            foreach ($widgets_list as $controller => $wid) {

                if (!$controller) { $controller = ''; }

                // Проверка на фильтр по контроллеру
                if ($this->config->filter_widget_control <> 'none') {
                    if ($controller != $this->config->filter_widget_control) { continue; }
                }

                foreach ($wid as $key => $val) {

                    $widget_name = $val['name'];

                    // Проверка на фильтр по имени виджета
                    if ($this->config->filter_widget_widget <> 'none') {
                        if ($widget_name != $this->config->filter_widget_widget) { continue; }
                    }

                    $list[$controller][$widget_name]['count'] = '';
                    $list[$controller][$widget_name]['time'] = '';
                }
            }

            // Сливаем с массивом количеств
            $widgets = array_replace_recursive($list, $this->widgets);

        } else {

            $widgets = $this->widgets;

        }

        ksort($widgets, SORT_STRING);

        foreach ($widgets as $c => $val) {

            ksort($val);

            foreach ($val as $w => $v) {

                $html .= '<tr>'.
                         '<td>'.$c.'</td>'.
                         '<td>'.$w.'</td>'.
                         '<td align="center">'.($v['count']>0 ? $v['count'] : '').'</td>'.
                         '<td align="center">'.$v['time'].'</td>'.
                         '<td align="center">'.($v['count']>0 ? round($v['time']/$v['count'], 1) : '').'</td>'.
                         '</tr>';
            }
        }

        $html = '<table><thead><tr>'.
                '<td><u><span class="widget">Controller</span></u></td>'.
                '<td><u><span class="widget">Widget</span></u></td>'.
                '<td><u>Count</u></td>'.
                '<td><u>Time sum, ms</u></td>'.
                '<td><u>Time avg, ms</u></td>'.
                '</tr></thead><tbody>'.$html;

        $html .= "</tbody></table>\n\n";

        return $html;
    }


//==============================================================================

    // -------------------------------------------------------------------------
    /**
    * Возвращает признак разрешения показывать отладочную информацию
    * @return bool Разрешено показывать отладку или нет
    */
    public function isAllowShow() {
        return (!$this->config->debug_admin_only || cmsUser::getInstance()->is_admin);
    }


//== DebugRuntime ==============================================================

    // -------------------------------------------------------------------------
    /**
    * Фиксирует начальные время работы и объём памяти на момент старта функций
    * обработки событий для подсчёта времени и памяти класса отладки
    */
    private function startDebugRuntime() {
        $this->debug_time_start = microtime(true);
        $this->debug_memory_start = memory_get_usage();
    }

    // -------------------------------------------------------------------------
    /**
    * Обновляет время работы и потраченную память класса отладки
    * Требует предварительной корректной фиксации начальных значений
    * $this->debug_time_start и $this->debug_memory_start
    * на момент старта функций обработки событий в отладке
    * @param bool $update_add Дополнительно вычитать время отладки инклудов, БД, кэша
    * из обрабатываемых в данный момент виджетов, хуков, контроллера, шаблона
    */
    private function updateDebugRuntime($update_add=false) {

        $this->debug_memory += memory_get_usage() - $this->debug_memory_start;
        $time = microtime(true) - $this->debug_time_start;
        $this->debug_time += $time;

        // Сдвигаем время начала учёта операций на время отладки инклудов, обращений к БД и кэшу
        if ($update_add) {

            if ($this->hook_time_start)     { $this->hook_time_start += $time; }
            if ($this->control_time_start)  { $this->control_time_start += $time; }
            if ($this->template_time_start) { $this->template_time_start += $time; }
            if ($this->render_time_start)   { $this->render_time_start += $time; }
            if ($this->widget_time_start)   { $this->widget_time_start += $time; }

            // Если уже считается время рендеринга виджета, то корректируем и его
            if ($this->widget_time_render)  { $this->widget_time_render += $time; }
        }
    }


//== Вспомогательные функции ===================================================

    // -------------------------------------------------------------------------
    /**
    * Возвращает округлённое до милисекунд значение времени $time
    * с количеством знаков после запятой $rnd
    * @param float $time Время в секундах
    * @param int $rnd Требуемое количество знаков после запятой
    * @return float Время в милисекундах
    */
    private function roundTime($time, $rnd = 1) {
        return round($time*1000, $rnd);
    }

    // -------------------------------------------------------------------------
    /**
    * Возвращает округлённое до мегабайт значение памяти $mem в байтах
    * с количеством знаков после запятой $rnd
    * @param float $mem Значение памяти в байтах
    * @param int $rnd Требуемое количество знаков после запятой
    * @return float Значение памяти в мегабайтах
    */
    private function roundMemory($mem, $rnd = 3) {
        return round($mem/1048576, $rnd);
    }

    // -------------------------------------------------------------------------
    /**
    * Возвращает процент $part по отношению к $full
    * с количеством знаков после запятой $rnd
    * @param float $full Значение, принимаемое за 100%
    * @param float $part Значение, для которого вычисляется процент
    * @param int $rnd Требуемое количество знаков после запятой
    * @return float Расчётный процент (при $full=0 возвращается 0)
    */
    private function percent($full, $part, $rnd = 0) {
        return ($full==0 ? 0 : round($part/$full * 100, $rnd));
    }

    // -------------------------------------------------------------------------
    /**
    * Возвращает выделенное тегом <strong> значение $check, если $check не равно 0.
    * В противном случае возвращается просто $check.
    * Если задано $subst, то оно подставляется вместо $check на выходе.
    * @param mixed $check Значение для проверки (и вывода)
    * @param mixed $subst Если задано, выводится вместо $check
    * @param bool $sign  Если задано, при положительных $check подставляется знак "+"
    * @return string Выделенное или нет одно из входных значений
    */
    private function strongNotNull($check=0, $subst='', $sign=false) {
        if (!$subst) { $subst = $check; }
        return ($check == 0 ? 0 : '<strong>'.($sign ? '+' : '').$subst.'</strong>');
    }

    // -------------------------------------------------------------------------
    /**
    * Возвращает массив с информацией о найденых вхождениях для фильтра по пути/имени вызывающего файла
    * @param string $from  Что искать и подсвечивать
    * @param array  $trace Массив с трассировкой
    * @return array Массив с ключами: bool 'result' - найдено?, array 'trace' - массив трассировки с подсветкой
    */
    private function filterFrom($from='', $trace='') {

        $ret['result'] = true;

        if (mb_stripos($trace['point'], $from) === false) {

            if (mb_stripos($trace['html'], $from) === false) {
                // Не найдено нигде
                return array('result' => false);
            } else {
                // Найдено во второй и далее строках трассировки - возвращаем её без подсветки
                $ret['trace']['point'] = $trace['point'];
            }

        } else {

            // Найдено в первой строке трассировки - подсвечиваем её
            $ret['trace']['point'] = $this->highliteStr($from, $trace['point']);
        }

        // Подсвечиваем вторую и далее строки трассировки
        $ret['trace']['html'] = $this->highliteStr($from, $trace['html']);

        return $ret;
    }

    // -------------------------------------------------------------------------
	/**
	* Возвращает массив со всеми строками полученными после SQL-запроса
	* или false, если $result не является объектом
	* @param object $result Результат SQL-запроса
    * @return array Массив со строками результата запроса или false
	*/
	public function getQueryRows($result){

		// Убеждаемся, что есть объект с данными
        if (!is_object($result)) { return false; }

        // Получаем массив строк
        $data=array();
        while($item = $result->fetch_assoc()) {
            $data[] = $item;
        }

        // Возвращаем указатель на первую строку
        $result->data_seek(0);

        return $data;
	}

    // -------------------------------------------------------------------------
    /**
    * Возвращает строку с подсветкой найденного ключа.
    * @param string $key Что искать и подсвечивать
    * @param string $str В чём искать
    * @return string Входная строка с подсветкой найденного
    */
    private function highliteStr($key='', $str='') {
        return str_ireplace($key, '<span class="highlite">'.$key.'</span>', $str);
    }


//== Оформление подстрок лога ==================================================

    // -------------------------------------------------------------------------
    /**
    * Возвращает оформленную строку текщего времени выполнения скрипта для лога
    * @param float $time  Время скрипта, сек. Если не задано, подставляется текущее
    * @return string Оформленная строка времени выполнения скрипта
    */
    private function getHtmlLogScriptTime($time=0) {

        if ($time == 0) {
            // Вычисляем по текущему моменту
            $time = $this->roundTime(microtime(true) - $this->time_start);
        } else {
            // Вычисляем по переданному времени
            $time = $this->roundTime($time - $this->time_start);;
        }

        return '[ <span class="help" title="Script time (time since the start of the script)">'.$time.' ms</span> ]';
    }

    // -------------------------------------------------------------------------
    /**
    * Возвращает оформленную строку про sql-запросы для лога
    * @param int     $sql_count Количество запросов
    * @param float   $sql_time  Время запросов, мс
    * @return string Оформленная строка
    */
    private function getHtmlLogSql($sql_count=0, $sql_time=0) {
        return '[ '.$this->strongNotNull($sql_count).' sql : '.$this->strongNotNull($sql_count, round($sql_time, 1)).' ms ]';
    }

    // -------------------------------------------------------------------------
    /**
    * Возвращает оформленную строку про инклуды для лога
    * @param int     $include_count Количество инклудов
    * @param float   $include_time  Время инклудов, мс
    * @return string Оформленная строка
    */
    private function getHtmlLogInclude($include_count=0, $include_time=0) {
        return '[ '.$this->strongNotNull($include_count).' incl : '.$this->strongNotNull($include_count, round($include_time, 1)).' ms ]';
    }

    // -------------------------------------------------------------------------
    /**
    * Возвращает оформленную строку про события и хуки для лога
    * @param int     $hook_events Количество событий
    * @param int     $hook_count  Количество хуков
    * @param float   $hook_time   Время хуков, мс
    * @return string Оформленная строка
    */
    private function getHtmlLogEventHook($hook_events=0, $hook_count=0, $hook_time=0) {
        return '[ '.$this->strongNotNull($hook_events).' events : '.$this->strongNotNull($hook_count).' hooks : '.$this->strongNotNull($hook_count, round($hook_time, 1)).' ms ]';
    }

    // -------------------------------------------------------------------------
    /**
    * Возвращает оформленную строку про память для лога хуков, виджетов, контроллера и т.д.
    * @param int     $memory Изменение памяти
    * @param string  $type   Тип подсчёта
    * @return string Оформленная строка
    */
    private function getHtmlLogMemory($memory=0, $type='') {
        return '[ <span class="help" title="Change">'.$this->strongNotNull($memory, round($memory/1024), true).' KB</span> ('.$type.') ]';
    }

    // -------------------------------------------------------------------------
    /**
    * Возвращает оформленную строку про память для лога точек отладки
    * @param int     $mem_delta Изменение памяти
    * @param int     $mem_cur   Текущая память
    * @param int     $mem_peak  Пик памяти
    * @return string Оформленная строка
    */
    private function getHtmlLogMemoryCP($mem_delta=0, $mem_cur=0, $mem_peak=0) {
        return '[ <span class="help" title="Change">'.$this->strongNotNull($mem_delta, '', true).' KB</span> : <span class="help" title="Current"><strong>'.$mem_cur.'</strong></span> / <span class="help" title="Peak"><strong>'.$mem_peak.'</strong></span> MB ]';
    }


//== Цветовое оформление кода ==================================================

	/**
	* Получает результат var_dump($mixed) и приводит его в красивый вид
	* @param mixed $mixed Переменная для дампа
    * @return string Результат красивого var_dump
	*/
    static function var_dump_color($mixed = null) {

        // Получаем var_dump входной переменной
        ob_start();
        var_dump($mixed);
        $out = ob_get_contents();
        ob_end_clean();

        // Убираем переносы строк после => и ставим окружающие пробелы
        $out = mb_ereg_replace('(]=>\n\s+)', '] => ', $out);

        // Вся разметка и специальные символы преобразуются в безопасные сущности
        $out = htmlspecialchars($out, ENT_QUOTES, 'UTF-8');

        // Заменяем двойные кавычки для индексов на одинарные
        $out = preg_replace_callback(
            '/^\s+(\[.+?\]) =&gt;/mu',
            function ($matches) {
                return str_replace('&quot;', '&apos;', $matches[0]);
            },
            $out
        );

        // Заменяем вывод bool() на более красивый
        $out = mb_ereg_replace('(^|=&gt; )bool\((true|false)\)', '\\1<span class="type">bool</span> <span class="const">\\2</span>', $out, 'im');
        // Заменяем вывод int() на более красивый
        $out = mb_ereg_replace('(^|=&gt; )(int)\((\d+)\)', '\\1<span class="type">\\2</span> \\3', $out, 'm');
        // Заменяем вывод float() на более красивый
        $out = mb_ereg_replace('(^|=&gt; )(float)\(([\d+\.*e*E*\+\-]*)\)', '\\1<span class="type">\\2</span> \\3', $out, 'm');
        // Заменяем вывод string() на более красивый
        $out = mb_ereg_replace('(^|=&gt; )(string\(\d+\))', '\\1<span class="type">\\2</span>', $out, 'm');
        // Выделяем жирным и цветом массивы и объекты
        $out = mb_ereg_replace('(^|=&gt; )(array)(\(\d+\))', '\\1<span class="type"><b>Array</b>\\3</span>', $out, 'm');
        $out = mb_ereg_replace('(^|=&gt; )(object)(\(.+?\))(\s\{)', '\\1<span class="type"><b>Object</b>\\3</span>\\4', $out, 'm');
        // Оформляем значение NULL в класс css
        $out = mb_ereg_replace('(=&gt; )(null)$', '\\1<span class="const">null</span>', $out, 'im');

        // Выделяем цветом индексы
        $out = mb_ereg_replace(
            '(^\s+)\[([^\]]+)\] =&gt;',
            '\\1<span class="square">[</span><span class="index">\\2</span><span class="square">]</span> <span class="arrow">=&gt;</span>',
            $out,
            'm'
        );

        // Удваиваем пробелы в начале строки для более наглядного отступа
        $out = mb_ereg_replace('(^\s+)(.*)', '\\1\\1\\2', $out, '');

        return '<pre class="params">'.$out.'</pre>';
    }

	/**
	* Подсвечивает SQL-синтаксис
	* @param string $sql Входная SQL-строка
    * @return string SQL-строка с подсветкой
	*/
    static function highliteSql($sql = '') {

        // Слова для поиска
        $words = array(
            // Знаки 1
            1 => array(' = ',' / ',' < ',' > ',':=','!=','<>','>=','<=',),
            // Операторы
            2 => array('ON DUPLICATE KEY UPDATE','SELECT ','UPDATE ','INSERT ','DELAYED ',
                      'DELETE ','USING ','REPLACE ','LIMIT ','SET ','FROM ','ORDER BY',
                      'WHERE ','GROUP BY','UNION ','INTO ','HAVING ','PROCEDURE ',
                      'CHARACTER SET ','PARTITION ','USE INDEX','USE KEY','IGNORE INDEX',
                      'IGNORE KEY','FORCE INDEX','FORCE KEY','FOR ',' IN ',' ON ',
                      'LEFT JOIN','RIGHT JOIN','INNER JOIN','STRAIGHT_JOIN ','JOIN ',
                      'VALUES',' VALUE',
                      'ALL ','DISTINCT ','LOW_PRIORITY','IGNORE ','PRIMARY','DEFAULT',
                      ' as ',' desc',' asc',
            ),
            // Логические операторы
            3 => array(' AND ',' OR ',' IS ',' NOT ',' !',' && ',' || ',' XOR ',' LIKE ',' BETWEEN ',),
            // Функции
            4 => array(' IFNULL','EXISTS',' NOW',' MIN',' MAX',' COUNT',' LOG',' OCT',),
            // Константы
            5 => array(' NULL','CURRENT_TIMESTAMP',),
            // Знаки 2
            6 => array('(',')','+','-','*'),
        );

        // Стили оформления
        $styles = array(
            1 => 'symbols',
            2 => 'statement',
            3 => 'operator',
            4 => 'function',
            5 => 'constant',
            6 => 'symbols',
        );

        // Текст
        $sql = mb_ereg_replace('(?:\')(.+?)(?:\')', '\'<span class="text">\\1</span>\'', $sql, '');

        // Числа
        $sql = mb_ereg_replace('(?:\s+)(\d+)', ' <span class="digits">\\1</span>', $sql, '');

        $i = 1;
        foreach($styles as $style) {

            foreach($words[$i] as $word) {
                $sql = str_ireplace($word, '<span class="'.$style.'">'.$word.'</span>', $sql);
            }

            // Перемещаем пробелы справа от <span> налево
            $sql = mb_ereg_replace('(\<span[\w\s"=-_]+\>)(\s+)(\w+?)', '\\2\\1\\3', $sql, '');
            // Перемещаем пробелы слева от </span> направо
            $sql = mb_ereg_replace('(\w+)(\s+)(\<\/span\>)', '\\1\\3\\2', $sql, '');
            $i++;
        }

        return $sql;
    }


//==============================================================================

    // -------------------------------------------------------------------------
    /**
    * Возвращает версию "Отладки"
    */
    static function getVersion() {
        return self::VERSION;
    }

    // -------------------------------------------------------------------------
    /**
    * Возвращает название константы типа ошибки по его номеру
    */
    private function getErrorType($errno) {

        $err = array (
            E_ERROR             => 'E_ERROR',
            E_WARNING           => 'E_WARNING',
            E_PARSE             => 'E_PARSE',
            E_NOTICE            => 'E_NOTICE',
            E_CORE_ERROR        => 'E_CORE_ERROR',
            E_CORE_WARNING      => 'E_CORE_WARNING',
            E_CORE_ERROR        => 'E_COMPILE_ERROR',
            E_CORE_WARNING      => 'E_COMPILE_WARNING',
            E_USER_ERROR        => 'E_USER_ERROR',
            E_USER_WARNING      => 'E_USER_WARNING',
            E_USER_NOTICE       => 'E_USER_NOTICE',
            E_STRICT            => 'E_STRICT',
            E_RECOVERABLE_ERROR => 'E_RECOVERABLE_ERROR',
            E_DEPRECATED        => 'E_DEPRECATED',
            E_USER_DEPRECATED   => 'E_USER_DEPRECATED',
            E_ALL               => 'E_ALL'
        );

        return (array_key_exists($errno, $err) ? $err[$errno] : $errno);
    }

  // =============================================================================

}
?>
